<!--

function helpPopup(helpUrl) 
{
    // function to pop-up a help window
    // helpUrl is the URL to use for the window contents
    // The window will be simple and not have any location bar or navigation buttons
    newHelpWindow = window.open(helpUrl,'helpwindow','width=700,height=500,resizable,scrollbars')
    newHelpWindow.focus()
}

function newTab(theUrl) 
{
    // function to open a new tab
    // theUrl is the URL to use for the window contents
    newWindow = window.open(theUrl)
    newWindow.focus()
}

function submitObject(value)
{
    document.forms[0].submit()
}

/* -----------WEBI added scripts ------------------------ */
var m_NumberofScalarObjs=0;
var m_NumberofTableRows=0;
var m_NumberofCardsInTable=0;
var m_SubmitButtonPressed=0;
var m_NumberofRowsSelected=0
var m_MAX_NUMPORTS = 256+128; /* max ports supported by app including special ports 257-385 */
                             /* WI_PORTNUMBERBASE in wiSlotsInfo.h max # port is 128 */
var m_PORTNAME        = "po_";
var WI_FORMOBJNAME    = "ob_";
var WI_TABLEINSTNAME  = "in_";
var WI_TABLEROWNAME   = "tr_";
var WI_TABLEINSTVALUE = "iv_";

var kVLANID_MAX = 4090;  /* for all systems */
var kVLANID_MAX_ONU64  = 3897;  /* For GPON with 64 ONUs per OLT */
var kVLANID_MAX_ONU128 = 3710;

var kSTAGID_MAX = 4090;  /* for all systems */
var kSTAGID_MAX_ONU64  = 3897;  /* For GPON with 64 ONUs per OLT */
var kSTAGID_MAX_ONU128 = 3710;

/* -----------WEBI Bitsmask handler variables ----------- */
var m_IsCheckBoxGroupOpen = false;
var m_NumBmaskTableRowsAdded = 0;
var m_AddBitSelectTableRowAt = 0;  /* Add a new row at this table row number */
var m_LastBitsMaskRegion= 0;
var m_ArrayBitsMaskSetting = new Array();
var m_CheckBoxStatusSetting = new Array();
var m_NumCheckBoxesAdded = 0;
var m_NumIntegralBits = 0;

var m_IsComboboxMenuOpen = false;
var m_LastComboboxRegion = 0;
var m_NumComboboxOptions = 0;
var m_ComboPopupMenu;
var m_ComboPopupMenuName = "";

var m_MaxAllowedRowSelect = 64;/* max 64 lines per table page */

/* Stores the scalar and form objects in array. Index 0 also holds the
 * m_NumberofScalarObjs value, others hold individual section OID count.
 * The HTML tag contains kobjcountfromcgi_1, kobjcountfromcgi_2 etc, 
 * initialized in the CGI handler.
 */
var m_MultiSectionOidObjCount = [0,0,0,0,0,0,0,0]; 
var m_kMaxOidSections = 8;  /* Check WI_MAXSNMPSECTIONS */


/* BridgeType Enum index. As in bridgeType MIB. These are used in bridge screens
 * Refer to BridgeHandler1.c
 */
var kBRLOG_DNLINK      = '2';
var kBRLOG_DNLINKDATA  = '14';
var kBRLOG_DNLINKPPPOA = '9';
var kBRLOG_DNLINKPPPOE = '15';
var kBRLOG_DNLINKP2P   = '16';
var kBRLOG_DNLINKUSMCAST = '18';
var kBRLOG_DNLINKVIDEO = '13';
var kBRLOG_DNLINKVOICE = '17';
var kBRLOG_INTRALINK   = '4';
var kBRLOG_MVR         = '11';
var kBRLOG_RLINK       = '8';
var kBRLOG_TLS         = '6';
var kBRLOG_UPLINK      = '1';
var kBRLOG_USER        = '12';
var kBRLOG_WIRE        = '10';
/* IPOBRIDGE TYPES */
var kBRLOG_IPOBUPLINK  = '20';
var kBRLOG_IPOBDNLINK  = '21';
var kBRLOG_IPOBTLS     = '19';

var ASCII_CHAR_a       = 97;
var ASCII_CHAR_z       = 122;
var ASCII_CHAR_A       = 65;
var ASCII_CHAR_Z       = 90;
var ASCII_ZERO         = 48;
var ASCII_NINE         = 57;
var ASCII_USCORE       = 95;
var ASCII_DASH         = 45;

/* copyright 1 February 2003, by Stephen Chapman, Felgall Pty Ltd */
function BrowserType() 
{
    var agt=navigator.userAgent.toLowerCase();

    if (agt.indexOf("opera") != -1) 
        return 'Opera';
    if (agt.indexOf("chrome") != -1) 
        return 'Chrome';
    if (agt.indexOf("staroffice") != -1) 
        return 'Star Office';
    if (agt.indexOf("webtv") != -1) 
        return 'WebTV';
    if (agt.indexOf("beonex") != -1)
        return 'Beonex';
    if (agt.indexOf("chimera") != -1) 
        return 'Chimera';
    if (agt.indexOf("netpositive") != -1) 
        return 'NetPositive';
    if (agt.indexOf("phoenix") != -1) 
        return 'Phoenix';
    if (agt.indexOf("firefox") != -1) 
        return 'Firefox';
    if (agt.indexOf("safari") != -1) 
        return 'Safari';
    if (agt.indexOf("skipstone") != -1) 
        return 'SkipStone';
    if (agt.indexOf("msie") != -1)  
        return 'Internet Explorer';
    if (agt.indexOf("netscape") != -1) 
        return 'Netscape';
    if (agt.indexOf("mozilla/5.0") != -1) 
        return 'Mozilla';
    if (agt.indexOf('\/') != -1) 
    {
        if (agt.substr(0,agt.indexOf('\/')) != 'mozilla')
        {
            return navigator.userAgent.substr(0,agt.indexOf('\/'));
        }
        else 
        {
            return 'Netscape';
        }
    } 
    else if (agt.indexOf(' ') != -1)
    {
        return navigator.userAgent.substr(0,agt.indexOf(' '));
    }
    else 
    {
        return navigator.userAgent;
    }
}


function f_GetNumberOfTableRows()
{
    return m_NumberofTableRows;
}

function f_SetNumberScalarObj(numObjs)
{
    m_NumberofScalarObjs = numObjs;
}

/* 
 * Creates form values dynamically, and sends to cgi for return as new Html 
 * Notes on use of 'name' vs 'id' in Javascript and Form data forwarding.
 * If 'name' is used, getElementsByName may be used to get all the fields using
 *  this name, but values may not be read by JS.
 * If id is used, JS has to use getElementById, and can properly read the values.
 * FORM'd text data is automatically forwarded to the server only if it's 
 * identified by name, not by id. So we cannot rely on any data posting feature
 * of Browser, rather manage those by JS. 
 * All instances of a form must be packed into tab delimited string.under in_1. 
 * 7/2/13 How do we associate ob_n values with in_m nodes? 
 * Instead of drawing in_1, _2 form in htmlformat, create as inst_n form in which
 * inst_n indicates using value of ob_n to assign in_1.
 * If there are 2 instances object2 and object 4, then htmlformat will create
 * 2 entires, instobj_2=value of obj2 and instobj_4=value of obj4. In createFORMData
 * walk the inst_n nodes, and split instobj_n to obtain n, and then obtain the value
 * in ob_n to assing in_1, in_2 etc.
 * 7/10/13. If an instance field is disabled then use the instance from instobj_x
 * because the disabled field may be port name, such as 3-8-n2n, that cannot be used.
 * instobj-x has the actual ifindex, and should be echoed back to cgi.
 */
function f_CreateFORMData(formDivIdent)
{
  /* ob_ is WI_FORMOBJNAME in wiGlobals.h */
    var numberInstances = 0;
    var theRowInstance;
    var rowListStr;
    var currDiv = document.getElementById(formDivIdent);

  /* #1 Add the button selected info */
    f_AddNewInputEntry(currDiv,"CL_BUTTON_NAME",m_SubmitButtonPressed);
   

  /* #2 Create the forms at this location. All objects are compressed into one
   *  object CL_HTTP_OBJECTLIST=value1\tvalue2\t.....
   * Hidden form objects should return 0 as value. cannot have gaps in response
   * value buffer.
   */
    var objectIdent;
    var objectValueStr;
    var bAddObjecList = true;
    var objectName;

    var totalFormObjects = m_NumberofScalarObjs;

    /* Process all objects in multi-section object list. The first one is
     * the default list, so totalFormObjects is already accounted for.
     */    
    for (i = 1; i < m_kMaxOidSections; i++ )
    {
        totalFormObjects += m_MultiSectionOidObjCount[i];
    }

    for (i = 1; i <= totalFormObjects; i++)
    {
        /* All scalar objects are identified by ob_*/
        objectName = WI_FORMOBJNAME+i;
        objectIdent = document.getElementById(objectName);

        if ( objectIdent == null )
        {
            if ( i == 1 )
            {
                bAddObjecList = false;
                break;
            }
        }
        if ( objectIdent != null )
        {
            if ( i == 1 )
            {
                objectValueStr = objectIdent.value;
            }
            else if ( i <= totalFormObjects )
            {
                objectValueStr = objectValueStr +"\t"+objectIdent.value;
            }
        }
        else
        {
            objectValueStr = objectValueStr +"\t"+0;
        }
    }

    if ( bAddObjecList == true )
    {
        var objectGroup = "CL_HTTP_OBJECTLIST";

        /* Add the object list. */
        f_AddNewInputEntry(currDiv,objectGroup,objectValueStr);
    } 

    /* #3 Walk through the objects and resolve value of inst nodes */
    for (i = 1; i <= totalFormObjects; i++)
    {
        /* If this is an instance, create an entry*/
        instanceName = WI_TABLEINSTNAME + i; /* i is the obj_i that has its value */
        var instanceValue = document.getElementById(instanceName);
        if ( instanceValue != null )
        {
            /* This identifies an instance, create an entry in_x. */
            objectName = WI_FORMOBJNAME + i;
            objectIdent = document.getElementById(objectName);

            if ( objectIdent != null )
            {
                /* This is an instance, create an entry in_x if the object is enabled. */
                if ( objectIdent.disabled == true )
                {
                    /* But if the entry is disabled, echo the value in embedded hidden input. */
                    objectName = WI_TABLEINSTNAME + i;
                    objectIdent = document.getElementById(objectName);
                }

                if ( numberInstances == 0 )
                {
                    theRowInstance = objectIdent.value;
                }
                else
                {
                    theRowInstance = theRowInstance +"\t"+objectIdent.value;
                }
                numberInstances++;
            }
        }
    }

    /* #4 All instances are concatenated into one tab delimited acscii string */
    if ( numberInstances > 0 )
    {
        f_AddNewInputEntry(currDiv,WI_TABLEINSTNAME+"1",theRowInstance);
        //4) Number of instances contained in the form.
        f_AddNewInputEntry(currDiv,"CL_SELECTROW_COUNT",1);
        //5) A dummy row list
        f_AddNewInputEntry(currDiv,"CL_SELECTROW_LIST",1);
    }
    return true;
}

/* Open from generic scalar form windows after user presses on Apply 
 * ###bitsmask value needs to be in octet string, not the string name ###
 */
function f_UpdateFORMData(askPrompt)
{
    var answer = true;

    if ( (askPrompt == true) &&
         ( (m_SubmitButtonPressed == "CL_MODIFY_OBJECT") ||
           (m_SubmitButtonPressed == "CL_APPLY_OBJECT") )  )
    {
        answer = confirm("Are you sure you want to modify the data?\n")
    }

    if ( answer == true )
    {
        /* If one or more bitsmask object exists, then copy the "int_" field
         * integer value to the "ob_" field, which will be sent to the cgi.
         */
        for (i=1; i <= m_NumberofScalarObjs; i++)
        {
            var objectName = WI_FORMOBJNAME+i;
            gf_UpdateBitsmaskObjValue(objectName);
        }

      //ob_ is WI_FORMOBJNAME in wiGlobals.h
        var currDiv = document.getElementById('kformobjectlist'); /* root node */

      //1) Add the button selected info
        f_AddNewInputEntry(currDiv,"CL_BUTTON_NAME",m_SubmitButtonPressed);

      //2) Create the forms at this location
        var objectGroup = "CL_HTTP_OBJECTLIST";
        var objectIdent;
        var objectValueStr;
 
        for (i = 1; i <= m_NumberofScalarObjs;i++)
        {
            var objectName = WI_FORMOBJNAME+i;

            objectIdent = document.getElementById(objectName);

            if ( (objectIdent != null) && (objectIdent != '') )
            {
                if ( i == 1 )
                {
                    objectValueStr = objectIdent.value;
                }
                else
                {
                    objectValueStr = objectValueStr +"\t"+objectIdent.value;
                }
            }
            else
            {
                document.writeln("f_UpdateFORMData:"+objectName + " is undefined");
            }
        }

        f_AddNewInputEntry(currDiv,objectGroup,objectValueStr);
        return true;
    }
    return false;
}
// Append form data at kformobjectlist. Used by custom windows
// as voip or iphost
function f_CreateStdFORMData()
{
    var currDiv = document.getElementById('kformobjectlist'); // root node
    var index;
    var objectGroup = "CL_HTTP_OBJECTLIST";
    var objectIdent;
    var objectValueStr;
    var objectName;
    var numObjects = m_StandardObjects.length;

    //1) Add the button selected info
    f_AddNewInputEntry(currDiv,"CL_BUTTON_NAME",m_SubmitButtonPressed);

    //2) Create the forms at this location
    for (index = 1; index <= numObjects; index++)
    {
        objectName = m_StandardObjects[index-1];
        /* Update a bitsmask type object value with its hex string */
        gf_UpdateBitsmaskObjValue(objectName);

        objectIdent = document.getElementById(objectName);
        if ( (objectIdent != '') && (objectIdent != null) )
        {
            if ( index == 1 )
            {
                objectValueStr = objectIdent.value;
            }
            else
            {
                objectValueStr = objectValueStr +"\t"+objectIdent.value;
            }
        }
        else
        {
            document.writeln("f_CreateStdFORMData:"+objectName + " is undefined");
        }
    }
    f_AddNewInputEntry(currDiv,objectGroup,objectValueStr);
    return true;
}

/* Initialize the number of scalar objects. The value may or may not be displayed, 
 * but is also used to create FORMs 
 */
function f_InitObjectCount()
{
    var objectData = document.getElementById('kobjcountfromcgi');
    m_NumberofScalarObjs = parseInt(objectData.value);
    m_MultiSectionOidObjCount[0] = m_NumberofScalarObjs;
    return m_NumberofScalarObjs;
}

/* Initialize the number of scalar objects. The value may or may not be displayed, 
 * but is also used to create FORMs 
 */
function f_InitObjCountSection(id)
{
    var objectData = document.getElementById('kobjcountfromcgi_'+id);
    if ( objectData == null )
    {
        document.writeln("f_InitObjCountSection: element "+id+" is undefined");
        return 0;
    }

    m_MultiSectionOidObjCount[id] = parseInt(objectData.value);
    return m_MultiSectionOidObjCount[id];
}

/* Initialize the number of rows, and display row count value on page */
function f_InitTableRowCount()
{
    var elem_rc;
    var rowData = document.getElementById('krowcountfromcgi');
    if ( rowData != null )
    {
        m_NumberofTableRows = rowData.value;
    }
    m_numberofRowsSelected = 0;

   /* Show the number of rows at top left corner of table.*/
    var rowCountDiv = document.getElementById('knumberoftablerows');
    if ( rowCountDiv != null )
    {
        var elem_tr=document.createElement('TR');
        rowCountDiv.appendChild(elem_tr);
        var elem_td=document.createElement('TD');
        rowCountDiv.appendChild(elem_td);
        if ( m_NumberofTableRows > 0 )
        {
            elem_rc=document.createTextNode("Number of entries : "+m_NumberofTableRows);
        }
        else
        {
            elem_rc=document.createTextNode("There are no entries in this table");
        }
        rowCountDiv.appendChild(elem_rc);
    }
    _ClearAllRowCheckBoxes();
    return m_NumberofTableRows;
}

/* Initialize the number of rows, and display row count value on page */
function f_InitCardTableEntryCount()
{
    var elem_rc;
    var cardCountData = document.getElementById('kcardsintablecountfromcgi');
    var rowData       = document.getElementById('krowcountfromcgi');
    if ( rowData != null )
    {
        m_NumberofTableRows    = rowData.value;
    }
    if ( cardCountData != null )
    {
        m_NumberofCardsInTable = cardCountData.value;
    }
    m_numberofRowsSelected = 0;

   /* Show the number of rows at top left corner of table.*/
    var rowCountDiv = document.getElementById('knumberoftablerows');
    if ( rowCountDiv != null )
    {
        var elem_tr=document.createElement('TR');
        rowCountDiv.appendChild(elem_tr);
        var elem_td=document.createElement('TD');
        rowCountDiv.appendChild(elem_td);
        if ( m_NumberofTableRows > 0 )
        {
            elem_rc=document.createTextNode("Number of cards : "+m_NumberofCardsInTable);
        }
        else
        {
            elem_rc=document.createTextNode("There are no cards in this table");
        }
        rowCountDiv.appendChild(elem_rc);
    }
    _ClearAllRowCheckBoxes();
    return m_NumberofTableRows;
}

/* Initialize the number of rows, and display row count value on page.
 * same as f_InitTableRowCount, but with specified labels. */
function f_InitTableEntryCount(entryLabel, noEntryLabel)
{
    var elem_rc;
    var rowData = document.getElementById('krowcountfromcgi');
    m_NumberofTableRows = rowData.value;
    m_numberofRowsSelected = 0;
    

   /* Show the number of rows at top left corner of table.*/
    var rowCountDiv = document.getElementById('knumberoftablerows');
    if ( rowCountDiv != null )
    {
        var elem_tr=document.createElement('TR');
        rowCountDiv.appendChild(elem_tr);
        var elem_td=document.createElement('TD');
        rowCountDiv.appendChild(elem_td);
        if ( m_NumberofTableRows>0 )
        {
            elem_rc=document.createTextNode(entryLabel+" : "+m_NumberofTableRows);
        }
        else
        {
            elem_rc=document.createTextNode(noEntryLabel);
        }
        rowCountDiv.appendChild(elem_rc);
    }
    _ClearAllRowCheckBoxes();
    return m_NumberofTableRows;
}

/* Creates instance values dynamically. One per check box selected */
function f_InsertInstanceValues(totalRows)
{
    var currDiv = document.getElementById('kinstancelist');
    var instName;
    var rowName;
    var i = 1; 

//tr_ is TABLEROWNAME  to name individual row's checkbox field, received from CGI
//iv_ is TABLEINSTVALUE to name individual row's instance value field
//in_ is TABLEINSTNAME  to name individual selected row 
//1) Add the button selected info "CL_BUTTON_NAME"
    f_AddNewInputEntry(currDiv,"CL_BUTTON_NAME",m_SubmitButtonPressed);
//2) Add number of rows selected. Information may or may not be useful to cgi "CL_SELECTROW_COUNT"
    f_AddNewInputEntry(currDiv,"CL_SELECTROW_COUNT",m_NumberofRowsSelected);
//3) List of all rows selected in comma delim format. Information may or may not be useful to cgi "CL_SELECTROW_LIST"
    if ( m_NumberofRowsSelected > 0 )
    {
        var rowSelCo = 0;
        var rowList;

        for (i = 1;i <= m_NumberofTableRows;i++)
        {
            rowName = WI_TABLEROWNAME+i;
            var checkButton=document.getElementById(rowName);
            if ( checkButton.checked )
            {   
                if ( (++rowSelCo) > 1 )
                {
                    rowList = rowList+","+i;
                }
                else
                {
                    rowList = i;
                }
            }
        }
        f_AddNewInputEntry(currDiv,"CL_SELECTROW_LIST",rowList);
//4) Add all the instances  "in_1" "in_2" "in_3" "in_4" etc
        for (i = 1;i <= m_NumberofTableRows; i++)
        {
            rowName    = WI_TABLEROWNAME + i;
            instName   = WI_TABLEINSTNAME + i;
            instValues = WI_TABLEINSTVALUE + i;
            var checkButton=document.getElementById(rowName);
            if ( checkButton.checked )
            {
                /* reads the prewritten instances in the table row */
                var instanceValues=document.getElementById(instValues); 
                f_AddNewInputEntry(currDiv,instName,instanceValues.value);
                if ( totalRows == 1 )
                {
                    return true; /* Only use the first one */
                }
            }
        }
    }
    return true;
}

/* Creates instance values in a bulk buffer instead of one per check box selected */
function f_InsertBulkInstanceValues(totalRows)
{
    var currDiv = document.getElementById('kinstancelist');
    var instName;
    var rowName;
    var i = 1; 

  //tr_ is TABLEROWNAME  to name individual row's checkbox field, received from CGI
  //iv_ is TABLEINSTVALUE to name individual row's instance value field
  //in_ is TABLEINSTNAME  to name individual selected row 
  //1) Add the button selected info
    f_AddNewInputEntry(currDiv,"CL_BUTTON_NAME",m_SubmitButtonPressed);

  //2) Add number of rows selected. Information may or may not be useful to cgi
    f_AddNewInputEntry(currDiv,"CL_SELECTROW_COUNT",m_NumberofRowsSelected);

  //3) List of all rows selected in comma delim format. Information may or may not be useful to cgi
    if ( m_NumberofRowsSelected>0 )
    {
        var rowSelCo = 0;
        var rowList;
    
        for (i = 1; i <= m_NumberofTableRows;i++)
        {
            rowName = WI_TABLEROWNAME+i;
            var checkButton=document.getElementById(rowName);
            if ( checkButton.checked )
            {
                if ( (++rowSelCo)>1 )
                {
                    rowList = rowList+","+i;
                }
                else
                {
                    rowList = i;
                }
            }
        }
        f_AddNewInputEntry(currDiv,"CL_SELECTROW_LIST",rowList);

        var instanceBuffer=null;
        var instanceBlockName="CL_INSTANCE_LIST";
        var numberRowsAdded=0;
        var InstBlockId = 1;
        var kMaxRowsPerBlock = 5;

        //4) Add all the instances
        for (i = 1; i <= m_NumberofTableRows; i++)
        {
            rowName    = WI_TABLEROWNAME + i;
            instName   = WI_TABLEINSTNAME + i;
            instValues = WI_TABLEINSTVALUE + i;

            var checkButton=document.getElementById(rowName);

            if ( checkButton.checked )
            {
                /* Reads the prewritten instances in the table row */
                var instanceValues=document.getElementById(instValues); 

                if (instanceBuffer == null)
                {
                    instanceBuffer = instanceValues.value + "\7";
                }
                else
                {
                    instanceBuffer = instanceBuffer + instanceValues.value + "\7";
                }
                if ( totalRows == 1 )
                {
                    f_AddNewInputEntry(currDiv,"CL_INSTANCE_LIST1",instanceBuffer);
                    return true;
                }
                if (++numberRowsAdded == kMaxRowsPerBlock)
                {
                    /* Create an entry with all instances of 10 rows */
                    f_AddNewInputEntry(currDiv,"CL_INSTANCE_LIST"+InstBlockId,instanceBuffer);
                    InstBlockId++;
                    instanceBuffer = null;
                    numberRowsAdded=0;
                }
            }
        }
        /* Create with remaining rows */
        if (numberRowsAdded<kMaxRowsPerBlock)
        {
            f_AddNewInputEntry(currDiv,"CL_INSTANCE_LIST"+InstBlockId,instanceBuffer);
        }
    }
    return true;
}

/* Creates one instance values using the given row */
function f_InsertInstanceValuesDefault(rowNumber)
{
    var currDiv = document.getElementById('kinstancelist');
    var instName;
    var rowName;
    var i = 1; 

  //tr_ is TABLEROWNAME  to name individual row's checkbox field, received from CGI
  //iv_ is TABLEINSTVALUE to name individual row's instance value field
  //in_ is TABLEINSTNAME  to name individual selected row 
  //1) Add the button selected info
    f_AddNewInputEntry(currDiv,"CL_BUTTON_NAME",m_SubmitButtonPressed);

  //2) Add number of rows selected=1.
    f_AddNewInputEntry(currDiv,"CL_SELECTROW_COUNT",1);

  //3) List of all rows selected in comma delim format. Information may or may not be useful to cgi
    var rowList = rowNumber
    f_AddNewInputEntry(currDiv,"CL_SELECTROW_LIST",rowList);

  //4) Add all the instances
    rowName    = WI_TABLEROWNAME + rowNumber;
    instName   = WI_TABLEINSTNAME + rowNumber;
    instValues = WI_TABLEINSTVALUE + rowNumber;

    /* reads the prewritten instances in the table row */
    var instanceValues=document.getElementById(instValues); 
    f_AddNewInputEntry(currDiv,instName,instanceValues.value);
    return true;
}

/* This handles the global row selectAll checkbutton for tables */
function f_RowSelectCheckBox()
{
    var checkButton=document.getElementById("m_SelectAllRows");
    if ( checkButton.checked )
    {
        /* Deselect all rows. */
        f_SetAllRowCheckBoxState(m_NumberofTableRows,true,WI_TABLEROWNAME,false);
    }
    else
    {
        /* Select all rows. However if selectAll is false, then use maxAllowedNumber */
        f_SetAllRowCheckBoxState(m_NumberofTableRows,false,WI_TABLEROWNAME,false);
    }
}

/* This handles the global row selectall for CFORM checkbutton, use scalar objs */
function f_SelectAllCheckBox(cbType)
{
    var checkButton=document.getElementById("m_SelectAllRows");
    if ( checkButton.checked )
    {
        /* Deselect all rows */
        f_SetAllRowCheckBoxState(m_NumberofScalarObjs,true,cbType,true);
    }
    else
    {
        /* Select all rows */
        f_SetAllRowCheckBoxState(m_NumberofScalarObjs,false,cbType,true);/* all rows affected*/
    }
}

/* For Card table check. Return the first row selected. */
function f_GetFirstRowChecked()
{
    for (i = 1;  i <= m_NumberofTableRows; i++)
    {
        var rowName = WI_TABLEROWNAME+i;
        var checkButton=document.getElementById(rowName);
        if ( checkButton.checked )
        {
            return i;
        }
    }
    return 0;
}

/* Return the check status of row selected. 
 * row is 1 based index
 */
function f_IsRowChecked(row)
{
    var rowName = WI_TABLEROWNAME+row;
    var checkButton=document.getElementById(rowName);

    if ( checkButton.checked )
    {
        return true;
    }
    return false;
}

/* For FORM check buttons. If noMaxLimit==true, then don't enforce limit */
function f_SetAllRowCheckBoxState(totalRows,checkboxState,namePref,noMaxLimit)
{
    var i;

    /* deselect all if box is set false */
    if ( checkboxState == false )
    {
        for (i = 1;  i <= totalRows; i++)
        {
            var rowName = namePref+i;
            var checkButton=document.getElementById(rowName);
            if ( checkButton != null )
            {
                checkButton.checked = false;
            }
        }
        m_NumberofRowsSelected = 0;
    }
    else
    {
        /*----------------- Check box select has no limitations -------*/
        if ( noMaxLimit == true )
        {
            m_NumberofRowsSelected = 0;

            /* All boxes are selected */
            for (i = 1;  i <= totalRows; i++)
            {
                var rowName = namePref+i;
                var checkButton=document.getElementById(rowName);
                if ( (checkButton != null) && (checkButton.disabled == false) )
                {
                    checkButton.checked = checkboxState;
                    if (checkboxState == true)
                    {
                        m_NumberofRowsSelected++;
                    }
                }
            }
        }
        else
        {
            /*------ If we are restricting select all to 10 rows only----- */
            /* If some rows are pre-selected, then allowed number must consider */
            var numberSelected = 0;

            for (i = 1;  i <= m_NumberofTableRows; i++)
            {
                var rowName = WI_TABLEROWNAME+i;
                var checkButton=document.getElementById(rowName);
                if ( checkButton != null )
                {
                    if (!checkButton.checked  && (checkButton.disabled == false))
                    {
                        if ( (numberSelected+m_NumberofRowsSelected+1) <= m_MaxAllowedRowSelect )
                        {
                            checkButton.checked = true;
                            numberSelected++;
                        }
                        else
                        {
                            break;
                        }
                    }      
                }    
            }
            m_NumberofRowsSelected += numberSelected;
        }
    }
}

/* Save checkbutton status after user presses a check button. No limit as to how many. */
function f_CheckNoLimit(id)
{
    var checkButton=document.getElementById(id);

    if ( checkButton.checked )
    {
        m_NumberofRowsSelected += 1;
        id.checked = true;
        return
    }
    id.checked = false;
    if ( m_NumberofRowsSelected >0 )
    {
        m_NumberofRowsSelected -= 1;
    }
}

/* Save checkbutton status after user presses a check button */
function f_Check(id)
{
    var checkButton=document.getElementById(id);

    if ( checkButton.checked )
    {
        if ( (m_NumberofRowsSelected+1) > m_MaxAllowedRowSelect )
        {
            id.checked = false;
            checkButton.checked = 0
            return
        }
        m_NumberofRowsSelected += 1;
        id.checked = true;
        return
    }
    id.checked = false;
    if ( m_NumberofRowsSelected > 0 )
    {
        m_NumberofRowsSelected -= 1;
    }
}

/* Return number of rows checked */
function f_NumberRowsChecked()
{
    return m_NumberofRowsSelected;
}

function f_SetButtonType(name)
{
  m_SubmitButtonPressed = name;
}

function f_GetButtonType()
{
  return m_SubmitButtonPressed;
}

function f_AlertMessage(buttonPressed) 
{
    if ( buttonPressed == "CL_DELETE_OBJECT" )
    {
        return "Are you sure you want to delete the selected entries?\n";
    }
    else if ( buttonPressed == "CL_DISABLE_OBJECT" )
    {
        return "Are you sure you want to disable the selected entries?\n";
    }
    else if ( buttonPressed == "CL_ENABLE_OBJECT" )
    {
        return "Are you sure you want to enable the selected entries?\n";
    }
    else if ( buttonPressed == "CL_PORTADMINUP" )
    {
        return "Are you sure you want to admin UP the selected entries?\n";
    }
    else if ( buttonPressed == "CL_PORTADMINDOWN" )
    {
        return "Are you sure you want to admin DOWN the selected entries?\n";
    }
    return "Are you sure you want to continue?\n";
}

/* Process table window button commands */
function f_ConfirmInput()
{
    var numberRows = f_NumberRowsChecked();
    var currDiv;

    switch(m_SubmitButtonPressed)
    {
        case "0":
        case 0:
            return false;
        break;

        case "CL_DELETE_OBJECT":
        case "CL_DISABLE_OBJECT":
        case "CL_ENABLE_OBJECT":
            if ( numberRows  == 0 )
            {
                alert("One or more rows must be selected");
                return false;
            }
            var answer = confirm(f_AlertMessage(m_SubmitButtonPressed));
            if ( answer )
            {
          //        return f_InsertBulkInstanceValues();
                return f_InsertInstanceValues(0);
            }
            return false;      
        break;

        case "CL_MODIFY_OBJECT":
        case "CL_VIEW_ALLOBJECTS":
        case "CL_ADD_BRIDGEPATH":
        case "CL_SHOW_BRIDGEPATH":
        case "CL_ADD_REDUNDANT":
        case "CL_SHOW_ALLPORTS":             
            if ( numberRows == 0 )
            {
                alert("One or more rows must be selected");
                return false;
            }
            return f_InsertInstanceValues(1); /* only the first one is used */
        break;

        default:
            currDiv = document.getElementById('kinstancelist');
          //1) Add the button selected info
            f_AddNewInputEntry(currDiv,"CL_BUTTON_NAME",m_SubmitButtonPressed);
          //2) Add number of rows selected. Information may or may not be useful to cgi
             f_AddNewInputEntry(currDiv,"CL_SELECTROW_COUNT",0);
          //3) Add number of rows available. Information may or may not be useful to cgi
             f_AddNewInputEntry(currDiv,"CL_TOTALROW_COUNT",m_NumberofTableRows);
        break;
    }
    return true;      
}

function f_SetTextEditElement(fieldId,displayMode)
{
  var divName = fieldId;
  var inputElement = document.getElementById(divName);

  if (inputElement != null) 
  {
     inputElement.style.visibility = displayMode;
  }
  else
  {
    document.writeln("JS:No such object "+fieldId);
  }
}
/* Cannot use width to hide menu items. ff3.0 draws an outline*/
function f_SetMenuElementView(menuElement,attribute)
{
    menuElement.style.visibility=attribute;  
}

/* To Add a new menu option. selectedindex needed for IE */
function f_AddMenuItem(popupMenu, value, text, isSelected )
{
    var menuItem   = document.createElement("OPTION");
    menuItem = new Option(text, value);
    menuItem.selected = isSelected;

    try
    {
        popupMenu.options.add(menuItem);
        if ( isSelected == true )
        {
            popupMenu.selectedIndex = popupMenu.options.length-1;
        }
    }
    catch(err)
    {
        console.debug("f_AddMenuItem:Invalid popupmenu "+text);
    }
}

/* To remove a menu option. selectedindex needed for IE */
function f_RemoveMenuItem(popupMenu, selectIndex)
{
    popupMenu.options.remove(selectIndex);
}

/*  Function : IsNetAddrGood (pAddrString)
 *   Purpose  : Verify whether the IP Address string is Good */
function IsNetAddrGood (pAddrString)
{   
    if ( (pAddrString == null)    ||
         (pAddrString.length <= 0)||
         (pAddrString.length > 15) )  
    {
        return false;
    }
    else if  (pAddrString ==  "0.0.0.0")
    {
        return false;
    }

    if ( GetNumberOfContigChars(pAddrString, ".") > 1 )
    {
        return false;
    }

    var addrArray = pAddrString.split(".");
    var addrChars;
    var cLen;

    if ( addrArray.length < 4 )
    {
        return false;
    }
    for (i=0; i<addrArray.length; i++)
    {
        addrChars = addrArray[i];
        cLen = addrChars.length;
        if ( cLen > 3 )
        {
            return false;
        }

        if (isNaN (addrChars))
        {
            return false;
        }
        itemValue = parseInt(addrChars);
        if ( itemValue>255 )
        {
            return false;
        }
    }
    return true;

}

/*  Function : IsPhysAddrGood (pAddrString)
 *  Purpose  : Verify whether the MAC Address string is Good
 */
function IsPhysAddrGood (pAddrString)
{   
    if ( (pAddrString == null) ||
         (pAddrString.length <= 0) ||
         (pAddrString.length>17) )  
    {
        return false;
    }
    else if  (pAddrString ==  "0:0:0:0:0:0")
    {
        return false;
    }
    var maxContigColons = GetNumberOfContigChars(pAddrString, ":");
    if ( maxContigColons > 1 )
    {
        return false;
    }

    var addrArray = pAddrString.split(":");
    var addrChars;
    var cLen;

    if ( addrArray.length < 6 )
    {
        return false;
    }
    for (i=0; i<addrArray.length; i++)
    {
        addrChars = addrArray[i];
        cLen = addrChars.length;
        if ( cLen > 2 )
        {
            return false;
        }

        /* Test for alphanumeric decimal or hex char */
        for (j=0; j<cLen; j++)
        {
            if (IsHexChar(addrChars.charAt(j)) == false)
            {
                return false;
            }
        }
    }
    return true;
}

/*  Function : IsIpV6AddrGood (pAddrString)
 *  Purpose  : Verify whether the IpV6 Address string is Good 
 * 2001:d845:f8::32:2
 * Number of colon cannot be > 8
 * 
 */
function IsIpV6AddrGood (pAddrString)
{   
    if ( (pAddrString == null) ||
         (pAddrString.length <= 0) )
    {
        return false;
    }
    else if  (pAddrString ==  "0:0:0:0:0:0:0:0")
    {
        return false;
    }

    var maxContigColons = GetNumberOfContigChars(pAddrString, ":");

    if ( maxContigColons > 2 )
    {
        return false;
    }

    var addrArray = pAddrString.split(":");
    var addrChars;
    var itemValue;
    var cLen;

    if ( addrArray.length > 8 )
    {
        return false;
    }
    /* must have at 1 :: if, number of octet blocks < 8 */
    if ( (addrArray.length < 8) && (maxContigColons != 2) )
    {
        return false;
    }

    for (i=0; i<addrArray.length; i++)
    {
        addrChars = addrArray[i];
        cLen = addrChars.length;
        if ( cLen > 4 )
        {
            return false;
        }

        /* Test for alphanumeric decimal or hex char */
        for (j=0; j<cLen; j++)
        {
            if (IsHexChar(addrChars.charAt(j)) == false)
            {
                return false;
            }
        }
    }
    return true;
}

/* Not a number, but must be hex, a,b,c,d,e,f */
function IsHexChar( oneChar )
{   
    var lowChar=oneChar.toLowerCase();

    if ( (lowChar == 'a') || (lowChar == 'b')  ||
         (lowChar == 'c') || (lowChar == 'd')  ||
         (lowChar == 'e') || (lowChar == 'f')  )
    {
        return true;
    }

    var itemValue = parseInt(oneChar);
    if (isNaN (oneChar))
    {
        return false;
    }

    if ( (itemValue >= 0) && (itemValue <= 9) )
    {
        return true;
    }
    return false;
}

/* number of max contiguous colon or dots */
function GetNumberOfContigChars( addrChars, theChar )
{
    var cLen = addrChars.length;
    var contigChars = 0;
    var maxContigChars = 0;

    for ( index = 0; index < cLen; index++ )
    {
        if ( addrChars.charAt(index) == theChar )
        {
            contigChars++;
        }
        else
        {
            if ( maxContigChars < contigChars )
            {
                maxContigChars = contigChars;
            }
            contigChars = 0;
        }
    }
    if ( maxContigChars < contigChars )
    {
        maxContigChars = contigChars;
    }
    return maxContigChars;
}

/* Create a new INPUT entry that is sent back to CGI */
function f_AddNewInputEntry(divName,objName,objValue)
{
  var elem_input=document.createElement('INPUT');
  elem_input.setAttribute("type","hidden");
  elem_input.setAttribute("name",objName);
  elem_input.setAttribute("value",objValue);
  divName.appendChild(elem_input); /* create a new input row to send to cgi */
}

/* ------------------ Bitsmask related methods ------------------------*/
/* ------------------ Bitsmask related methods ------------------------*/
/* ------------------ Bitsmask related methods ------------------------*/

/* Create a new INPUT Checkbox entry. It's child of cell.
 * objName = chk_ob_5.1 chk_ob_5.2 chk_ob_5.3 etc. 1 for each cbutton.
 * cboxIndex is 0 based
 */
function f_AddNewInputCheckBox(divName,objName,objValue,isChecked,isDisabled,
                               cboxIndex)
{
    var elem_input=document.createElement('INPUT');

    elem_input.type  = "checkbox";
    elem_input.id    = objName;
    elem_input.value = objValue;
    elem_input.align = "left";
    divName.appendChild(elem_input); 

    if (isChecked)
    {
        /* Initial setting for checkbox state. User changes after clicking on button.
         */
        m_ArrayBitsMaskSetting[cboxIndex] = 1;
        elem_input.checked = true;
    }
    if (isDisabled == 1)
    {
        elem_input.disabled = true;
    }
}

/* When user pressed on [...] to close the bitsmask, the current checkbox settings
 * have to be transferred to m_ArrayBitsMaskSetting. Since IE8 does not support
 * onclick() event we have to xfer the setting to bitsmask array.
 */
function _TransferCheckBoxesToBitsArray()
{
    if ( m_LastBitsMaskRegion == null )
    {
        return;
    }
    var maxCBoxes = 128;
    var cbox = "chk_" + m_LastBitsMaskRegion; /* the current box open */
    for ( index = 1; index <= maxCBoxes; index++) 
    {
        var cboxName = cbox + "."+index;
        var cboxVar = document.getElementById(cboxName);
        if ( cboxVar == null )
        {
            break;
        }
        if ( cboxVar.checked )
        {
            m_ArrayBitsMaskSetting[index-1] = 1;
        }
        else
        {
            m_ArrayBitsMaskSetting[index-1] = 0;
        }
    }
}

/* Handler for bitsmask check boxes.
 * When [...] button is pressed, toggle between open and close.
 * If the child rows are closed, then based on value of m_ArrayBitsMaskSetting
 * create 2 checkbox inputs per row, and extend the current row.
 * The actual output hexstring is stored under int_OBJECTNAME. When output is
 * created this value is sent to the server.
 * titlebar is true if the bitsmask is used in a form page, and the
 * name/value/unit/range (nvur) title is part of the table, and not
 * a separate table.
 */
function gf_SetBitsMaskCheckBoxes(objectName,bodyName,titlebar)
{
    if ( m_IsCheckBoxGroupOpen == true )
    {
        /* -------------------- When the region is CLOSED ------------------------ */
        /* -------------------- When the region is CLOSED ------------------------ */
        /* -------------------- When the region is CLOSED ------------------------ */

        if ( (m_LastBitsMaskRegion != 0) && (m_LastBitsMaskRegion != objectName) )
        {
            /* Incorrect region is being closed. */
            return;
        }
        _TransferCheckBoxesToBitsArray(); /* From cbox to array */
        _ConvertCheckBoxesToBitsIntValue(objectName,bodyName,titlebar);
        m_LastBitsMaskRegion  = 0;
        m_IsCheckBoxGroupOpen = false;
    }
    else
    {
        /* -------------------- When the region is OPENED ------------------------*/
        /* -------------------- When the region is OPENED ------------------------*/
        /* -------------------- When the region is OPENED ------------------------*/

        if ( (m_LastBitsMaskRegion != 0) && (m_LastBitsMaskRegion != objectName) )
        {
            /* A region is still open. */
            return;
        }

        m_LastBitsMaskRegion  = objectName;
        _ConvertBitsIntValueToCheckBoxes(objectName,bodyName,titlebar);
        m_IsCheckBoxGroupOpen = true;
    }
}

/* _ConvertBitsIntValueToCheckBoxes
 * Execute this section after user presses [...] and OPENS the bitsmask button 
 */
function _ConvertBitsIntValueToCheckBoxes(objectName,bodyName,titlebar)
{
    m_NumBmaskTableRowsAdded = 0;

    var chkIntName = "int_"+objectName;
    var chkStsName = "sts_"+objectName;
    var chkStrName = "str_"+objectName;
    var chkRowName = "row_"+objectName;
    var chkObjName = "chk_"+objectName;

    /* The int_ object contains integer value of bitsmask. Decode that to 
     * set the checkbox up/down state. objIntValue.value is integer. */
    var objIntName = document.getElementById(chkIntName);
    var objIntValue = objIntName.value; /* c03f set by htmlformat routine */

    /*. Convert to bits array. m_ArrayBitsMaskSetting has bits settings 1 0 1 1 1 etc */
    _DecodeInt2Bitsmask(m_ArrayBitsMaskSetting,objIntValue);

    /* The sts_ object contains 0,0,0,1,1,... status attribs of the check boxes. 
     * set the checkbox enable/disable state based on this string. */
    var objStatusName = document.getElementById(chkStsName);
    var objStatusValue = objStatusName.value; /* 0,0,0,0,1 set by htmlformat routine */
    /*. Convert to bits array. m_CheckBoxStatusSetting has bits settings 1 0 1 1 1 etc */
    _DecodeStr2Bitsmask(objStatusValue);

    /* Parse the str value to indiv fields, and use as labels for check box.
     * enumstr1,enumstr2,enumstr3,... will be shown as
     * enumstr1 []  enumstr2[]  enumstr3[] etc. In as many lines required. */
    var objStrValue    = document.getElementById(chkStrName);
    var enumStrings    = objStrValue.value.split(",");
    var numEnumStrings = enumStrings.length;
    m_NumIntegralBits  = numEnumStrings; /* = number of bits */
    m_NumCheckBoxesAdded = 0;

    /* Get the row number of this object from "row_"+name */
    var cboxRowName = document.getElementById(chkRowName);
    /* The row number should be incremented after each row creation */
    var cboxRowNumber = cboxRowName.value;
    m_AddBitSelectTableRowAt = cboxRowNumber;
    if ( titlebar == true )
    {
        cboxRowNumber ++;
    }
    var mainTable = document.getElementById(bodyName);

    for ( index=0; index < numEnumStrings; index++)
    {
        var newRow = mainTable.insertRow(cboxRowNumber);
        m_NumBmaskTableRowsAdded++;  /* Total new rows. */

        if ( m_NumCheckBoxesAdded < numEnumStrings )
        {
            var cell1  = newRow.insertCell(0);
            cell1.height = 30;
            var totalCBAdded = m_NumCheckBoxesAdded+1;
            /* Cbox name. Use format chk_NAME.3. ".index: to find the right cbox */
            var cboxName = chkObjName+"."+totalCBAdded;

            if ( m_ArrayBitsMaskSetting[m_NumCheckBoxesAdded] == 1 ) 
            {
                f_AddNewInputCheckBox(cell1,cboxName,"1",true,
                                      m_CheckBoxStatusSetting[m_NumCheckBoxesAdded],
                                      m_NumCheckBoxesAdded);
            }
            else
            {
                f_AddNewInputCheckBox(cell1,cboxName,"1",false,
                                      m_CheckBoxStatusSetting[m_NumCheckBoxesAdded],
                                      m_NumCheckBoxesAdded);
            }
            var cell1Text = document.createTextNode(enumStrings[m_NumCheckBoxesAdded]); 
            cell1.appendChild(cell1Text); /* Create a new checkbox */

            m_NumCheckBoxesAdded ++;
        }
        else
        {
            break;
        }
        var cell2  = newRow.insertCell(1);/* Empty */

        /* Next cell */
        if ( m_NumCheckBoxesAdded < numEnumStrings )
        {
            var cell3=newRow.insertCell(2);
            var totalCBAdded = m_NumCheckBoxesAdded+1;

            var cboxName = chkObjName+"."+totalCBAdded;

            if ( m_ArrayBitsMaskSetting[m_NumCheckBoxesAdded] == 1 ) 
            {
                f_AddNewInputCheckBox(cell3,cboxName,"1",true,
                                      m_CheckBoxStatusSetting[m_NumCheckBoxesAdded],
                                      m_NumCheckBoxesAdded);
            }
            else
            {
                f_AddNewInputCheckBox(cell3,cboxName,"1",false,
                                      m_CheckBoxStatusSetting[m_NumCheckBoxesAdded],
                                      m_NumCheckBoxesAdded);
            }

            var cell3Text = document.createTextNode(enumStrings[m_NumCheckBoxesAdded]); 
            cell3.appendChild(cell3Text); /* Create a new checkbox */

            m_NumCheckBoxesAdded ++;
        }
        else
        {
            break;
        }
        var cell4  = newRow.insertCell(3); /* Empty */

        cboxRowNumber++; /* Absolute number */
    }
}

/* _ConvertCheckBoxesToBitsIntValue
 * Execute this section after user presses [...] and CLOSES the bitsmask button 
 */
function _ConvertCheckBoxesToBitsIntValue(objectName,bodyName,titlebar)
{
    var chkIntName = "int_"+objectName;
    var chkStrName = "str_"+objectName;

    /* Remove the added rows, but first copy the cbox settings. */
    var mainTable = document.getElementById(bodyName);

    /* Copy the current setting, and convert to integer, and close region */
    var objIntValue = document.getElementById(chkIntName);

    /* Update the value field by encoding the cbits to hex string */
    var bmIntValueHexStr = EncodeBitsmask2Int(m_ArrayBitsMaskSetting,m_NumIntegralBits);
    objIntValue.value = bmIntValueHexStr; /* C3 */

    /* Update the display field. First create display string. */
    var objStrValue = document.getElementById(chkStrName);

    var enumStrings = objStrValue.value.split(",");
    var displayStrings = "";
    for (index = 0; index < m_NumCheckBoxesAdded; index++)
    {
        if ( m_ArrayBitsMaskSetting[index] == 1 )
        {
            if ( displayStrings == "")
            {
                displayStrings = enumStrings[index];
            }
            else
            {
                displayStrings += " "+enumStrings[index];
            }
        }
    }

    /* Change the text in the input text field. Upon submit, change the field
     * text to the actual integer value. */
    objStrValue = document.getElementById(objectName);
    if ( displayStrings != "" )
    {
        objStrValue.value = displayStrings;
    }
    else
    {
        objStrValue.value = "";
    }

    /* Delete all rows created */
    if ( titlebar == true )
    {
        m_AddBitSelectTableRowAt ++;
    }
    for (index = 0; index < m_NumBmaskTableRowsAdded; index++)
    { 
        mainTable.deleteRow(m_AddBitSelectTableRowAt);
    }
    _ClearArrayBuffer(m_ArrayBitsMaskSetting);
}


/* Called after Apply button is pressed in the generic form window. */
function f_ValidateGenericSubmit(FormDivName,FormBodyName,titlebar)
{
    var buttonPressed = m_SubmitButtonPressed.substring(0,3);
    var confirmMsg = "Are you sure you want to apply the data?\n";


    if( buttonPressed == "CL_")
    {
        if ( (m_LastBitsMaskRegion != 0) )
        {
            if ( FormBodyName == null )
            {
                alert("Bitsmask form name is undefined");
            }
            gf_SetBitsMaskCheckBoxes(m_LastBitsMaskRegion,FormBodyName,titlebar);
        }

        if ( m_LastComboboxRegion != 0 )
        {
            if ( FormBodyName == null )
            {
                alert("Combobox form name is undefined");
            }
            /* formname is not required in closing the box */
            gf_SetHtmlComboBox(m_LastComboboxRegion,null,titlebar); 
        }

        if ( m_SubmitButtonPressed == "CL_ADD_OBJECT" )
        {
            confirmMsg = "Are you sure you want to create new table entry?\n"
        }


        var answer = confirm(confirmMsg)
        if ( answer )
        {
            /* If one or more bitsmask object exists, then copy the "int_" field
             * integer value to the "ob_" field, which will be sent to the cgi.
             */
            for (i=1; i <= m_NumberofScalarObjs; i++)
            {
                var objectName = WI_FORMOBJNAME+i;
                gf_UpdateBitsmaskObjValue(objectName);
            }
            /* Create the standard value string for all objects. */
            f_CreateFORMData(FormDivName);
            return true;
        }
    }
    return false;
}

/* Replaces the current string value of the bitsmask type object with its
 *  hex string value. instead of bits test string bit0 bit 1  "
 * Change to  "C0" The CGI form reader can only process the octet string
 * Only bitsmask object has a checkbox
 * format. 01/12/2012 SC
 */
function gf_UpdateBitsmaskObjValue(objectName)
{  
    /* Get the row number of this object from "row_"+name */
    var cboxRowName = document.getElementById("row_" + objectName);

    if (cboxRowName != null)
    {
        /* Found a cbox. Read integer e.g., "C81E" */
        var objIntName = document.getElementById("int_"+objectName);
        
        if ( objIntName != null )
        {
            /* Change the value of value in INPUT text */
            cboxRowName = document.getElementById(objectName);
            if (cboxRowName != null) 
            {
                cboxRowName.value = objIntName.value;
            }
        }
    }
}

function _ClearArrayBuffer(theArray)
{
    theArray.length = 0;
}
 
/* Convert the object value "0,0,0,0,1,0,0" to bit string */
function  _DecodeStr2Bitsmask(objStatusValue)
{
    var enumStrings = objStatusValue.split(",");
    var numEnumStrings = enumStrings.length;
    for (var index = 0; index < numEnumStrings; index++)
    {
        if ( enumStrings[index] == "1" )
        {
            m_CheckBoxStatusSetting[index] = 1; 
        }
        else
        {
            m_CheckBoxStatusSetting[index]=0;
        }
    }
}

/* Convert the object value C345.. to MSB bit string */
function _DecodeInt2Bitsmask(bitsArray,sOctValueStr)
{
    var lOctValue;
    var iBitIndex = 0;
    var numIter = sOctValueStr.length/2;
    var id1=0, id2=2;

    for (index=0; index<numIter; index++)
    {
        octString = sOctValueStr.substring(id1,id2);
        lOctValue = Hex2Decimal(octString);
        iBitIndex += _DecodeOct2Bitsmask(bitsArray,iBitIndex,lOctValue);
        id1 += 2;
        id2 += 2;
    }
}

function _DecodeOct2Bitsmask(bitsArray,bitIndex,lObjValue)
{
    var compValue;

    compValue = 0x80;

    for (i=0; i<8; i++)
    {
        if (lObjValue & compValue)
        {
            bitsArray[bitIndex] = 1;
        }
        else
        {
            bitsArray[bitIndex] = 0;
        }
        compValue /= 2;
        bitIndex ++;
    }
    return 8; 
}

/* Convert the object value to MSB bit hex string 
 * intValueStr is the output string.
 */
function EncodeBitsmask2Int(bitsArray,numIntegralBits)
{
    intValueStr = new String();
    /* Break the value in 8 bit octet */
    var i; j=0;
    var numOfOctets = Math.floor(numIntegralBits/8);

    if ( numIntegralBits > numOfOctets * 8 )
    {
        numOfOctets++;
    } 

    for ( oct =0; oct<numOfOctets; oct++ )
    {
        var intValue=0;

        for (i = 7; i >= 0; i--)
        {
            if ( bitsArray[j] == 1 )
            {
                intValue += Math.pow(2,i);
            }
            j++;
        }
        hexValue = Decimal2Hex(intValue);
        if (intValue<16)
        {
            intValueStr += "0";
        }
        intValueStr += hexValue.toString();
    }
    return intValueStr;
}

var hD="0123456789ABCDEF";

function Decimal2Hex(d) 
{
    var h = hD.substr(d&15,1);  
    while(d>15) 
    {
        d >>= 4;
        h=hD.substr(d&15,1)+h;
    }
    return h;
}

function Hex2Decimal(h) 
{
    return parseInt(h,16);
}


/* --------------- For Checkbox Port -----------------------------*/
/* Compute the number of ports */
function f_InitNumberOfPorts()
{
    var uNumberOfPorts=0;
    f_InitObjectCount();

    for (i = 1; i <= m_MAX_NUMPORTS; i++)
    {
        var checkBtnName = m_PORTNAME+i;
        var checkButton = document.getElementById(checkBtnName);
        if ( checkButton )
        {
            uNumberOfPorts++;
        }
    }
    return uNumberOfPorts;
}

/* Handle the selectall and clearall buttons */
function f_CheckPortButtonInput(id,uNumberOfPorts)
{
    for (i = 1;  i <= m_MAX_NUMPORTS; i++)
    {
        var checkBtnName = m_PORTNAME+i;
        var checkButton = document.getElementById(checkBtnName);
        if ( checkButton )
        {
            if (id == "CL_SELECT_ALL")
            {
                if ( checkButton.disabled != true )
                {
                    checkButton.checked=true;
                }
            }
            else if (id == "CL_CLEAR_ALL")
            {
                checkButton.checked=false;
            }
        }
    }
  return false;
}

/* Find the number of Ports selected */
function f_NumberOfPortsSelected(uNumberOfPorts)
{
    var numberSelected = 0;

    for (i = 1;  i <= m_MAX_NUMPORTS; i++)
    {
        var checkBtnName = m_PORTNAME+i;
        var checkButton = document.getElementById(checkBtnName);
        if ( checkButton )
        {
            if ( checkButton.checked )
            {
                numberSelected++;
            }
        }
    }
    return numberSelected;
}

/* Create the port button value for data post 
 * interfaceName is text string for interface name.
 * delayValue = provision delay per port
 */
function f_ConfirmUserInput(numberSelected,interfaceName,delayValue)
{
    var answer = true;
    var estimateDelay = "Are you sure you want to create "+numberSelected+" "+interfaceName+"?";

    if ( m_SubmitButtonPressed == "CL_APPLY_OBJECT" )
    {
        delayValue = Math.round(delayValue/10);
        delayValue = delayValue*10;
        if (delayValue>10)
        {
            estimateDelay = estimateDelay + "\nIt may take approximately ";
            estimateDelay = estimateDelay + f_SecondsToHMS(delayValue);
            estimateDelay = estimateDelay + ".\n";
        }
        if ( numberSelected == 0 )
        {
            alert("No ports selected");
            return false;
        }
        answer = confirm(estimateDelay);
    }

    if ( answer )
    {
        //All object values have to be set before the data is sent to the server.
        f_CreateStdFORMData();

        //po_ is WI_PORTOBJNAME in wiGlobals.h
        var currDiv = document.getElementById('kformobjectlist');
        var checkBtnGroup = "CL_HTTP_PORTLIST";
        var checkBtnList;
        numberSelected = 0;

        for (i = 1;  i <= m_MAX_NUMPORTS; i++)
        {
            var checkBtnName = m_PORTNAME+i;
            var checkButton = document.getElementById(checkBtnName);
            if ( checkButton )
            {
                if ( checkButton.checked )
                {
                  if ( numberSelected == 0 )
                  {
                      checkBtnList = i;
                  }
                  else
                  {
                      checkBtnList = checkBtnList + "\t" + i;
                  }
                  numberSelected++;
                }
             }
        }
        f_AddNewInputEntry(currDiv,checkBtnGroup,checkBtnList);
        return true;
    }
    return false;
}
/* --------------- End Checkbox Port -----------------------------*/

function gf_SetItemValue(index,value)
{
    objectName = m_StandardObjects[index-1]; /* index is 1 based */
    if ( objectName == null )
    {
        alert("gf_SetItemValue:"+object+" ["+index+"] is undefined");
        return;
    }
    objectValue = document.getElementById(objectName);
    if ( (objectValue == null) || (objectValue == "") )
    {
        return;
    }
    objectValue.value = value; /* setAttrib does not work for check buttons!!*/
}

function gf_GetItemValue(index)
{
    objectName = m_StandardObjects[index-1];
    objectValue = document.getElementById(objectName);
    return objectValue.value;
}

function gf_AddMenuItem(popupMenu, value, text )
{
  var menuItem   = document.createElement("OPTION");
  menuItem.text  = text;
  menuItem.value = value;
  popupMenu.options.add(menuItem);
}

//  Function : gf_SetNetAddrValue (pAddrString)
//  Purpose  : Convert to addr array
function gf_SetNetAddrValue (outAddr, pAddrString)
{ 
    if ( (pAddrString == null)    ||
         (pAddrString.length <= 0)||
         (pAddrString.length >15 ) )  
    {
        alert("Not a valid address type string. "+pAddrString);
        return 0;
    }
    else if  (pAddrString == "0.0.0.0")
    {
        alert("A null address string");
        return 0;
    }
    var addrArray = pAddrString.split(".");
    var addrChars;
    var itemValue;

    if ( addrArray.length != 4 )
    {
        alert("Address must be 4 octets");
        return 0;
    }

    for (i=0; i<addrArray.length; i++)
    {
        addrChars = addrArray[i];
        if ( addrChars != null )
        {
            if (isNaN (addrChars))
            {
                alert("Address string contains a non-number");
                return 0;
            }
            itemValue = parseInt(addrChars);

            if ( itemValue > 255 )
            {
                alert("Address string contains a number>255");
                return 0;
            }
            outAddr[i]=itemValue;
        }
        else 
            outAddr[i]=0;
    }
    return 1;
}

//  Function : gf_ConvertAddrValue (pAddrString)
//  Purpose  : Same as gf_SetNetAddrValue, but no alert string
function gf_ConvertAddrValue (outAddr, pAddrString)
{ 
  if ( (pAddrString == null)    ||
       (pAddrString.length <= 0)||
       (pAddrString.length >15 ) )  
  {
      return 0;
  }
  else if  (pAddrString == "0.0.0.0")
  {
      return 0;
  }
  var addrArray = pAddrString.split(".");
  var addrChars;
  var itemValue;

  if ( (addrArray.length != 4) )
  {
      return 0;
  }

  for (i=0; i<addrArray.length; i++)
  {
      addrChars = addrArray[i];
      if ( addrChars != null )
      {
          if (isNaN (addrChars))
          {
              return 0;
          }
          itemValue = parseInt(addrChars);

          if ( itemValue>255 )
          {
              return 0;
          }
          outAddr[i]=itemValue;
      }
      else 
      {
         outAddr[i]=0;
      }
  }
  return 1;
}

//  Function : gf_ConvertAddrValueZeroOk (pAddrString)
//  Purpose  : Same as gf_SetNetAddrValue, but no alert string and 0.0.0.0 is OK
function gf_ConvertAddrValueZeroOk (outAddr, pAddrString)
{ 
  if ( (pAddrString == null)    ||
       (pAddrString.length <= 0)||
       (pAddrString.length > 15 ) )  
  {
      return 0;
  }
  var addrArray = pAddrString.split(".");
  var addrChars;
  var itemValue;

  if ( (addrArray.length != 4) )
  {
      return 0;
  }

  for (i=0; i<addrArray.length; i++)
  {
      addrChars = addrArray[i];
      if ( addrChars != null )
      {
          if (isNaN (addrChars))
          {
              return 0;
          }
          itemValue = parseInt(addrChars);

          if ( itemValue>255 )
          {
              return 0;
          }
          outAddr[i]=itemValue;
      }
      else 
      {
         outAddr[i]=0;
      }
  }
  return 1;
}

function gf_ComputeBroadcastAddress( bCastAddr, subnetMask, ipAddress )
{
    var bySubnet    = new Array();
    var byIpAddr    = new Array();
    var cvalue=0;

    if ( gf_SetNetAddrValue (bySubnet,subnetMask) == 0 )
    {
        alert("Invalid Subnet Mask");
        return 0;
    }
    if ( gf_SetNetAddrValue (byIpAddr,ipAddress) == 0 )
    {
        alert("Invalid IP Address");
        return 0;
    }
    for (var i = 0; i<4; i++)
    {
        cvalue = ~bySubnet[i];
        if ( cvalue<0 )
        {
            cvalue += 256;
        }
        bCastAddr[i] = byIpAddr[i] | cvalue;
    }
    return 1;
}

function gf_ComputeNetworkAddress( netwAddr, subnetMask, ipAddress )
{
    var bySubnet  = new Array();
    var byIpAddr  = new Array();
    var cnetvalue;

    if ( gf_SetNetAddrValue (bySubnet,subnetMask) == 0 )
    {
        return 0;
    }
    if ( gf_SetNetAddrValue (byIpAddr,ipAddress) == 0 )
    {
        return 0;
    }
    for (var i = 0; i<4; i++)
    {
        cnetvalue = byIpAddr[i] & bySubnet[i];
        netwAddr[i] = cnetvalue;
    }
    return 1;
}

/* Hide or show specific span of a page
 * divTableBody = span ID
 * displayMode = 1 to show, 0 to hide
 */
function gf_SetDisplayMode(divTableBody,displayMode)
{
    var currDiv = document.getElementById(divTableBody);
    if ( currDiv == null )
    {
        return;
    }
    if ( (displayMode == 1) || (displayMode == true) )
    {
        currDiv.style.display="inline";
    }
    else
    {
        currDiv.style.display="none";
    }
}

 /* Hide or show specific span of a page
 * divTableBody = span ID
 * displayMode = 1 to show, 0 to hide
 * Note: we don't use inline mode here
 */
function gf_SetDisplayModeV2(divTableBody,displayMode)
{
    var currDiv = document.getElementById(divTableBody);
    if ( currDiv == null )
    {
        return;
    }

    if ( (displayMode == 1)||(displayMode == true) )
    {
        currDiv.style.display="";
    }
    else
    {
        currDiv.style.display="none";
    }
}

/* ---------------- row adjustment functions ------- */
function gf_ChangeRowDisplayMode(FormName,mode,row)
{
    var table = document.getElementById(FormName);
    if ( table == null )
    {
        return false;
    }

    if ( (mode == 0) || (mode == false))
    { 
        //Mode is advanced. Show all objects
        var rowname = WI_TABLEROWNAME+row;
        var rowIdent = document.getElementById(rowname);
    
        if ( rowIdent != null )
        {
            rowIdent.style.display = 'none';
        }
        else 
        {
            return false;
        }
    }
    else
    { 
        //Mode is standard. Hide advanced objects   
        var rowname = WI_TABLEROWNAME+row;
        var rowIdent = document.getElementById(rowname);

        if ( rowIdent != null )
        {
            rowIdent.style.display = '';
        }
        else 
        {
            return false;
        }
    }
    return true;
}

//Hides the advanced tool icon
function gf_HideAdvancedIcon(divName)
{
    var inputElement = document.getElementById(divName);
    if ( inputElement == null )
    {
        return;
    }

    inputElement.setAttribute("height","0");
    inputElement.setAttribute("width","0");
}

/* ---------- Column adjustment functions ----------
 * called by window
 */

function gf_GetWindowDisplayMode()
{
    return top.defaultdisplaymode;
}

function gf_SetWindowDisplayMode(mode)
{
    top.defaultdisplaymode = mode;
}

function gf_ToggleWindowDisplayMode()
{
    top.defaultdisplaymode = !top.defaultdisplaymode;
}

function gf_SetDisplayDefault(TableName,isChkbox)
{
    var column,colIndex;

    if ( m_NumberAdvanced>0 )
    {
        for (column=m_NumberAdvanced; column>0; column--)
        {
            colIndex = m_AdvanceColsIndex[column-1];
            if ( gf_ChangeColumnDisplayMode(TableName,!top.defaultdisplaymode,
                                            colIndex-1+isChkbox) == false )
            {
                console.debug("JS: Invalid cell "+colIndex);
            }
        }
    }
    else
    {
        gf_HideAdvancedIcon("advancedIcon","hidden");
    }
}

/* ---------- Column adjustment fucntions. Toggle states ----------*/
function gf_OpenAdvanced(TableName,isChkbox)
{
    var column,colIndex;

    if ( m_NumberAdvanced>0 )
    {
        for (column=m_NumberAdvanced; column>0; column--)
        {
            colIndex = m_AdvanceColsIndex[column-1];
            if ( gf_ChangeColumnDisplayMode(TableName,top.defaultdisplaymode,
                                            colIndex-1+isChkbox) == false )
            {
                alert("JS: Invalid cell "+colIndex);
            }
        }
    }
    top.defaultdisplaymode = !top.defaultdisplaymode;
}

function gf_ChangeColumnDisplayMode(TableName,mode,column)
{
    var table = document.getElementById(TableName);
    var rows = table.getElementsByTagName('TR');

    if ( mode == true )
    {
        for (var r = 0; r < rows.length; r++)
        {
            var cells = rows[r].getElementsByTagName('TD');
            if ( cells[column] != null )
            {
                cells[column].style.display = 'none';
            }
            else
            {
                return false;
            }
        }
    }
    else
    {     
        for (var r = 0; r < rows.length; r++)
        {
            var cells = rows[r].getElementsByTagName('TD');
            if ( cells[column] != null )
            {
                cells[column].style.display = '';
            }
            else
            {
                return false
            }
        }
    }
    return true;
}

/* f_InitTablePageList. 2/23/07
 * Show the page list. 'kpagecountfromcgi' and 'klistoftablepages' are
 * hardcoded. Also read kpagenumberfromcgi to highlight the current page.
 * Page : 1 | 2 | 3 | 4  each num is underlined for hyperlink.
 */
function f_InitTablePageList(tablePageHLink)
{
    var pageData = document.getElementById('kpagecountfromcgi');
    var numberOfPages = pageData.value;
    if (numberOfPages == 0)
      numberOfPages = 1; 

    var currPageNum = 0; /* If undefined no hilite needed */
    var currPageNumElem = document.getElementById('kpagenumberfromcgi');
    if ( currPageNumElem != null )
        currPageNum   = currPageNumElem.value;

    /* Show the page list in rows of 20 per row, as in Page 1 2 3 4 5 6 */
    var pageListDiv = document.getElementById('klistoftablepages');

    if ( pageListDiv != null )
    {
        var pageRef;
        var pageText="";
        var elem_txt,elem_a;
    
        for (index = 1;  index <= numberOfPages; index++)
        {
            pageText = index;
            elem_a   = document.createElement('a');

            pageRef          = tablePageHLink+"/"+pageText+"~";
            elem_a.href      = "/"+pageRef;
      
            if ( currPageNum == index )
              elem_a.innerHTML = "<B><font color=\"#B93B8F\">"+pageText+"</B></font>";
            else
              elem_a.innerHTML = pageText;

            if ( index == 1 )
              elem_txt=document.createTextNode("Page : ");
            else
              elem_txt=document.createTextNode(" | ");
            pageListDiv.appendChild(elem_txt);

            pageListDiv.appendChild(elem_a);
        }
    }
}

/* Converts seconds to hr min sec */
function f_SecondsToHMS(dwTime)
{
    var  dwDay=0, dwSecLeft=0, dwHr=0, dwMin=0;
    var  outBuffer=" ";
  
    dwDay = Math.floor(dwTime/86400); /* Integer */
    dwSecLeft = dwTime - dwDay*86400;
    dwHr = Math.floor(dwSecLeft/3600);
    dwSecLeft = dwSecLeft - (dwHr*3600);
    dwMin = Math.floor(dwSecLeft/60);
    dwSecLeft = dwSecLeft - (dwMin*60);

    if (dwDay>0)
       outBuffer = dwDay+" day ";
    if (dwHr>0)
       outBuffer = outBuffer + dwHr+" hr ";
    if (dwMin>0)
       outBuffer = outBuffer + dwMin+" min ";
    if (dwSecLeft>0)
       outBuffer = outBuffer + dwSecLeft+" sec";
    return outBuffer;
}

/* f_CreateObjectSelectCheckList
 * Used to create a bitmap string of all form objects selected.
 * Create HTTP object CL_HTTP_ENABLEDLIST.
 * If numberOfIndex>0, then prepend this many bits set to 0. For index.
 */
function f_CreateObjectSelectCheckList
    ( 
        formObjectName, 
        numberOfObjects, 
        numberOfIndex 
    )
{
    var currDiv = document.getElementById(formObjectName);
    /* ----- Add object select list. cb_ is WI_CBOXROWNAME in wiGlobals.h ----*/
    var checkBtnGroup = "CL_HTTP_ENABLEDLIST";
    var numberSelected = 0;
    var checkBtnList;

    if ( numberOfIndex > 0 )
    {
        for (i = 1;  i <= numberOfIndex; i++)
        {
            if ( numberSelected == 0 )
            {
                checkBtnList = 0;
            }
            else
            {
                checkBtnList = checkBtnList + "\t" + 0;
            }
            numberSelected++;
        }
    }

    for (i = 1;  i <= numberOfObjects; i++)
    {
        checkBtnName = "cb_"+i;
        checkButton  = document.getElementById(checkBtnName);
        if ( checkButton != null )
        {
            if ( checkButton.checked )
            {
                if ( numberSelected == 0 )
                {
                    checkBtnList = 1;
                }
                else
                {
                    checkBtnList = checkBtnList + "\t" + 1;
                }
                numberSelected++;
            }
            else 
            {
                if ( numberSelected == 0 )
                {
                    checkBtnList = 0;
                }
                else
                {
                    checkBtnList = checkBtnList + "\t" + 0;
                }
                numberSelected++;
            }
        }
    }
    f_AddNewInputEntry(currDiv,checkBtnGroup,checkBtnList);
}

/* Copy the standard object values to respective fields. The values are
 * initialized by the scalar or table handler in CGI.  5/29/08
 * Conversion from cgi data to html object requires recognition of object
 * type, such as checkboc, menu item. Setting default menu selection is not
 * possible via this API. Also checkbox uses 1/0 to determine if pressed on
 * not.
 */
function f_UpdateStandardObjectValues(browser)
{
    var numObjects = m_StandardObjects.length;
    var index, fieldValue;

    for (index = 1;  index <= numObjects; index++)
    {
        objectName = document.getElementById(m_StandardObjects[index-1]);
        if ( objectName )
        {
            fieldValue = m_StandardObjValues[index-1]; 
            /* alert(m_StandardObjects[index-1]+"="+fieldValue+", Type = "+objectName.type); */
            if ( fieldValue != 0 )
            { 
                /* don't overwrite any field if it's 0 */
                objectName.value = fieldValue;
            }
            if ( objectName.type == "checkbox" )
            {
                if ( objectName.value == "1" )
                {
                    objectName.checked = true;
                }
                else
                {
                    objectName.checked = false;
                }
            } 
        }
        else
        {
            document.writeln("JS:No such object "+m_StandardObjects[index-1]);
            break;
        }
    }
}

function _ClearAllRowCheckBoxes()
{
    f_SetAllRowCheckBoxState(m_NumberofTableRows,false,WI_TABLEROWNAME,false);
}

/* ------  set an object value. look it up by name ---*/
function f_SetItemValueByName(objectName,value)
{
    objectValue = document.getElementById(objectName);
    if ( objectValue != null )
    {
        objectValue.value = value; /* setAttrib does not work for check buttons!!*/
    }
    else
    {
        alert("f_SetItemValueByName:"+objectName +" is undefined");
    }
}

/* ------  get an object value. look it up by name ---*/
function f_GetItemValueByName(objectName)
{
    objectValue = document.getElementById(objectName);
    if ( objectValue != null )
    {
        return objectValue.value
    }
    else
    {
        alert("f_GetItemValueByName:"+objectName +" is undefined");
    }
    return 0;
}

/* --------Only allow a-z, A-Z, 0-9, and "-" as allowable characters to be accepted ---*/ 
function f_ValidAsciiCharString(objectName)
{
    var index, intValue, textValue;
    var isValid = true;

    for ( index = 0; index < objectName.length; index++)
    {
        textValue = objectName.charAt(index);
        intValue = f_AsciiValue(textValue);
        if ( ( (intValue >= 65) && (intValue <= 90) )  ||
             ( (intValue >= 97) && (intValue <= 122) ) ||
             ( (intValue >= 48) && (intValue <= 57) )  ||
             ( (intValue == 45) ) )
        {
            isValid = true;
        }
        else
        {
            return false;
        }
    }
    return true;
}

/* Source: From Internet */
function f_AsciiValue (c)
{
	  /* restrict input to a single character */
	  c = c . charAt (0);
	  /* loop through all possible ASCII values */
	  var i;
	  for (i = 0; i < 256; ++ i)
	  {
		    /* convert i into a 2-digit hex string */
		    var h = i.toString (16);
		    if (h.length == 1)
        {
  			    h = "0" + h;
        }
		    /* insert a % character into the string */
		    h = "%" + h;
		    /* determine the character represented by the escape code */
		    h = unescape (h);
		    /* if the characters match, we've found the ASCII value */
		    if (h == c)
        {
			      break;
        }
	  }
	  return i;
}

/* The following VLAN tagging logic must be implemented for non-gpon cards
 * untagged(1)    - allow vlan 0-4090        slan = 0-4090
 * single tag(2)  - must be non zero 1-4090  slan = 0-4090
 * double tag93)  - allow vlan 0-4090        slan must be non-zero  1-4090  
 *
 * Used to show VLAN range
 * For 64 ONUs VLAN range is 1-3897. For 128 it is 3711 
 * Input fieldName = Range field text
 *       cardType = "gpon" or others
 *       uNumOfPorts = Total ports
 *       All gpon connections must have nonzero range
 */
function f_UpdateVlanRange(fieldName,cardType,uNumOfPorts,tagType)
{
    var kLowRange = "1";
 
    switch (tagType)
    {
        case "1":/* untagged */
        case "3":/* doubletagged */
            kLowRange = "0";
        break;
    }

    if ( cardType == "gpon" )
    {
        if ( uNumOfPorts == 64 )
        {
            rangeText = "("+kLowRange+" - "+kVLANID_MAX_ONU64+")";
            f_SetItemValueByName(fieldName,rangeText);
            return kVLANID_MAX_ONU64;
        }
        if ( uNumOfPorts == 128 )
        {
            rangeText = "("+kLowRange+" - "+kVLANID_MAX_ONU128+")";
            f_SetItemValueByName(fieldName,rangeText);
            return kVLANID_MAX_ONU128;
        }
    } 
    rangeText = "("+kLowRange+" - "+kVLANID_MAX+")";
    f_SetItemValueByName(fieldName,rangeText);
    return kVLANID_MAX;
}

/* If VLAN ID is outside the valid range, return false, 
 * and show alert message. Min value can be 1 or 0.
 */
function f_ValidateVlanValue(vlanId, kVlanIdMin, kVlanIdMax)
{
    if (kVlanIdMin == 0)
    {
        if ( (vlanId == "") || (vlanId == " ") )
        {
            /* If low range is 0, then null entry is OK */
            return true;
        }
    }
    if ( (vlanId < kVlanIdMin) || (vlanId > kVlanIdMax) )
    {
        alert("VLAN must be between "+kVlanIdMin+" and "+kVlanIdMax);
        return false;
    }
    return true;
}

/* Used to show STAG range
 * For 64 ONUs STAG range is 1-3897. For 128 it is 3711 
 * Input fieldName = Range field text
 *       cardType = "gpon" or others
 *       uNumOfPorts = Total ports
 *       All gpon connections must have nonzero range
 */
function f_UpdateStagRange(fieldName,cardType,uNumOfPorts,tagType)
{
    var kLowRange = "1";

    switch (tagType)
    {
        case "1": /* untagged */
        case "2": /* tagged */          
            kLowRange = "0";
        break;
    }

    if ( cardType == "gpon" )
    {
        if ( uNumOfPorts == 64 )
        {
            rangeText = "("+kLowRange+" - "+kSTAGID_MAX_ONU64+")";
            f_SetItemValueByName(fieldName,rangeText);
            return kSTAGID_MAX_ONU64;
        }
        if ( uNumOfPorts == 128 )
        {
            rangeText = "("+kLowRange+" - "+kSTAGID_MAX_ONU128+")";
            f_SetItemValueByName(fieldName,rangeText);
            return kSTAGID_MAX_ONU128;
        }
    } 
    rangeText = "("+kLowRange+" - "+kSTAGID_MAX+")";
    f_SetItemValueByName(fieldName,rangeText);
    return kSTAGID_MAX;
}

/* If STAG ID is outside the valid range, return false, 
 * and show alert message. Min value can be 1 or 0.
 */
function f_ValidateStagValue(stagId, kStagIdMin, kStagIdMax)
{
    if (kStagIdMin == 0)
    {
        if ( (stagId == "") || (stagId == " ") )
        {
            /* If low range is 0, then null entry is OK */
            return true;
        }
    }
    if ( (stagId < kStagIdMin) || (stagId > kStagIdMax) )
    {
        alert("S-TAG must be between "+kStagIdMin+" and "+kStagIdMax);
        return false;
    }
    return true;
}

/* f_GetTokenByIndex
 * Tokenize by delimiter and return the index element, 0 based
 */
function f_GetTokenByIndex(textString, delimiter, index)
{
    var splitString = textString.split(delimiter);
    if ( index < splitString.length )
    {
        return splitString[index];
    }
    return textString;
}

/* Returns the value of a specific object in the selected row */
function f_GetRowInstanceString(rowNumber)
{
    var objectValue = "";

    if (rowNumber > 0)
    {
        var rowName = WI_TABLEINSTVALUE+rowNumber;
        var instValueBuffer = document.getElementById(rowName);  
        objectValue = instValueBuffer.value;
    }
    return objectValue;
}

/* gf_SetHtmlComboBox
 * Handler for combo text/pulldown menu. The function is called from
 * f_SetHtmlComboBox function contained in the template.
 * When ( v ). button is pressed, toggle between open and close.
 * In the open state, create a drop down menu immediately below the input box.
 * and open the selection. When an entry is selected, close the drop-down
 * and echo the text to the TE input box and copy to m_ComboboxOptionSelected
 * If an opened ( v ) button is clicked, then just close the deop-dwon without
 * transferring any selection.
 *
 * titlebar is true if the bitsmask is used in a form page, and the
 * name/value/unit/range (nvur) title is part of the table, and not
 * a separate table.
 */
function gf_SetHtmlComboBox(objectName,formname,bodyName,titlebar,cellOffset)
{
    if ( (m_LastComboboxRegion != 0) && (m_LastComboboxRegion != objectName) )
    {
        /* If user is opening this region (objName) while a different one 
         * (m_LastComboboxRegion) is still open, then return. We could close
         * the previous one, but that causes problems with row deleted. For now
         * return NOP.
         */
        return;
    }
    if ( m_IsComboboxMenuOpen != true )
    {
        /* -------- Region is closed is being OPENED ------- */
        _OpenTheCombobox(objectName,formname,bodyName,titlebar,cellOffset);
    }
    else
    {
        /* -------- Region is open is being CLOSED --------- */
        _CloseTheCombobox(bodyName, titlebar,cellOffset)
    }
}

/* Remove the added row and its child box, but first save the 
 * combobox settings. 
 */
function _CloseTheCombobox(bodyName, titlebar)
{
    var mainTable = document.getElementById(bodyName);

    if ( titlebar == true )
    {
        m_AddComboTableRowAt++;
    }

    try
    {
        mainTable.deleteRow(m_AddComboTableRowAt);
        m_LastComboboxRegion = 0;
        m_IsComboboxMenuOpen = false;
        m_ComboPopupMenu     = null;
    }
    catch (err)
    {
        return;
    }
}

/* Open the combobox when user clicks on ( v ) button
 * The input params are:
 * objectname = ob_xx where xx is row number
 * formname = FORM label, eg, generictable
 * bodyName = Div name of the table
 * titlebar = true is name/value/unit/range columns are part of
 *  this form.
 * We assume that the combopopup is drawn in the 3rd cell of the table.
 * [     ] []  [           ]v
 * 
 */
function _OpenTheCombobox(objectName,formname,bodyName,titlebar,cellOffset)
{
    var chkStrName = "str_"+objectName;
    var chkRowName = "row_"+objectName;

    m_LastComboboxRegion = objectName;

    /* Parse the str value to indiv fields, and use as labels for option.
     * enumstr1,enumstr2,enumstr3,... will be shown as option of dropdown menu
     */
    var objStrValue    = document.getElementById(chkStrName);
    var enumStrings    = objStrValue.value.split(",");
    var numEnumStrings = enumStrings.length;
    m_NumComboboxOptions  = numEnumStrings; /* = number of options */

    /* Get the row number of this object from "row_"+name */
    var cboxRowName = document.getElementById(chkRowName);
    /* The row number should be incremented after each row creation */

    var cboxRowNumber = cboxRowName.value;

    m_AddComboTableRowAt = cboxRowNumber;
    if ( titlebar == true )
    {
        cboxRowNumber++;
    }

    /* The main body of the page */
    var mainTable = document.getElementById(bodyName);

    /* Insert a new row after the current one */
    var thisRow = mainTable.insertRow(cboxRowNumber);

    /* Add cell #0 */
    var thisCell;
    var emptycell;

    for ( cell = 0; cell < cellOffset; cell++)
    {
        thisCell  = thisRow.insertCell(cell);
        thisCell.height  = 1;
        if (cell > (cellOffset-1) )
        {
            break;
        }
        emptycell = document.createTextNode(" ");
        thisCell.appendChild(emptycell);
    }
    /* Get the width of the INPUT field to align the combomenu */    
    var cObjRowElem = document.getElementById(objectName);
    var InputSize = cObjRowElem.size; /* Width of the parent INPUT field */

    /* Create a new popup  SELECT .... /SELECT in cell 3*/
    m_ComboPopupMenuName ="combopopupmenu";
    /* Global popup menu handle */
    m_ComboPopupMenu = _AddNewSelectObject(thisCell, 
                                           m_ComboPopupMenuName,
                                           InputSize);
    /* On change call the function */
    m_ComboPopupMenu.onchange = function(){_ComboboxHandler()};

    /* First one is empty line. Need empty for selection */
    _AddMenuItem(m_ComboPopupMenu, "", "", true);
    for ( i = 1; i <= m_NumComboboxOptions; i++) 
    {
        _AddMenuItem(m_ComboPopupMenu, 
                     enumStrings[i-1], 
                     enumStrings[i-1],false);
    }
    m_IsComboboxMenuOpen = true;
}

/* Create a new INPUT popup menu entry. It's child of cell3. 
 * objname is ob_xx where xx is row number;
 * parentsize = width of the TE window. 7.8 pixel per WIDTH
 * _ComboboxHandler must be provided in the form template
 */
function _AddNewSelectObject(divName,objName,parentsize)
{
  var xwidth = (7.8 * parentsize);
  var intvalue = parseInt(xwidth) + 1;
  
  var strvalue = "";
  var strvaluestyle = "";
  strvalue = intvalue;
  strvaluestyle = "width:";
  strvaluestyle = strvaluestyle + strvalue;
  strvaluestyle = strvaluestyle + "px";
    

  var elem_input=document.createElement('SELECT');
  elem_input.setAttribute(name,objName);
  elem_input.setAttribute("WIDTH",strvalue);
  elem_input.setAttribute("STYLE",strvaluestyle);
  divName.appendChild(elem_input); /* create a new input row to send to cgi */

  return elem_input;
}

function _AddMenuItem(popupmenu, value, text, iselected)
{
/*  
    ### This works in Firefox but not in IE8.0 ###
    var menuOption = document.createElement("OPTION");
    menuOption.value=value;
    menuOption.text=text;
    popupmenu.appendChild(menuOption);

    if ( iselected == true )
    {
        popupmenu.selectedIndex = popupmenu.options.length-1;
    }
*/
 /* ### This works in both Firefox and in  IE8.0 ### */

    var menuItem   = document.createElement("OPTION");
    menuItem = new Option(text, value);
    popupmenu.options.add(menuItem);
    if ( iselected == true )
    {
        popupmenu.selectedIndex = popupmenu.options.length-1;
    }
}

/* Hardcoded in messages.dat to call this func if a generic option 
 * is selected  Add custom function in each form when required.
 */
function f_MenuOptionSelect(id)
{
    return;
}

/* Cookie management functions */
function gf_CreateCookie(name,value,days) 
{
    if (days) 
    {
        var date = new Date();

        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = "; expires="+date.toGMTString();
    }
    else 
    {
        var expires = "";
    }
    var cookieStr = name+"="+value+expires+"; path=/";
    document.cookie = cookieStr;
}

function gf_ReadCookie(name) 
{
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');

    if ( ca == null )
    {
        return null;
    }
    for(var i=0;i < ca.length;i++) 
    {
        var c = ca[i];
        while (c.charAt(0)==' ') 
        {
            c = c.substring(1,c.length);
        }
        if (c.indexOf(nameEQ) == 0) 
        {
            return c.substring(nameEQ.length,c.length);
        }
    }
    return null;
}

function gf_EraseCookie(name)
{
    gf_CreateCookie(name,"",-1);
}

function beginDrag(elementToDrag, event)
{
	  var deltaX = event.clientX - parseInt(elementToDrag.style.left);
	  var deltaY = event.clientY - parseInt(elementToDrag.style.top);

	  if (document.addEventListener)
    {
		    document.addEventListener("mousemove", moveHandler, true);
		    document.addEventListener("mouseup", upHandler, true);
	  }
	  else if (document.attachEvent)
    {
		    document.attachEvent("onmousemove", moveHandler);
		    document.attachEvent("onmouseup", upHandler);
	  }
	  else 
    {
		    var oldmovehandler = document.onmousemove;
		    var olduphandler = document.onmouseup;
		    document.onmousemove = moveHandler;
		    document.onmouseup = upHandler;
	  }

	  if (event.stopPropagation) 
    {
        event.stopPropagation();
    }
	  else 
    {
        event.cancelBubble = true;
    }
	  if (event.preventDefault) 
    {
        event.preventDefault();
    }
	  else 
    {
        event.returnValue = false;
    }

	  function moveHandler(e)
    {
		    if (!e) 
        {
            e = window.event;
        }
		    elementToDrag.style.left = (e.clientX - deltaX) + "px";
		    elementToDrag.style.top = (e.clientY - deltaY) + "px";
		    if (e.stopPropagation) 
        {
            e.stopPropagation();
        }
		    else 
        {
            e.cancelBubble = true;
        }
	  }

	  function upHandler(e)
    {
		    if (!e) 
        {
            e = window.event;
        }
		    if (document.removeEventListener)
        {
			      document.removeEventListener("mouseup", upHandler, true);
			      document.removeEventListener("mousemove", moveHandler, true);
		    }
		    else if (document.detachEvent)
        {
			      document.detachEvent("onmouseup", upHandler);
			      document.detachEvent("onmousemove", moveHandler);
		    }
		    else 
        {
			      document.onmouseup = olduphandler;
			      document.onmousemove = oldmovehandler;
		    }

		    if (e.stopPropagation) 
        {
            e.stopPropagation();
        }
		    else 
        {
            e.cancelBubble = true;
        }
	  }
}

function ShowWaitCursor()
{
    document.body.style.cursor='wait';
}

function ShowDefaultCursor()
{
    document.body.style.cursor='default';
}

/* Verify GPON traffic profile boundary conditions */
function _VerifyBandwidthValue(fieldId, objName, gtzero, 
                               minValue2, maxValue, multiple)
{
    var bwValue = f_GetItemValueByName(fieldId);

    if ( gtzero == true ) 
    {
        if ( bwValue == 0) 
        {
            alert (objName + " must be > 0");
            return false;
        }
    }
    else
    {
        /* Min value can be minValue1 or minValue2 */
        if ( bwValue != 0 )
        {
            if (bwValue < minValue2) 
            {
                alert (objName + " minimum must be 0 or "+minValue2);
                return false;
            }
        }
    }

    if ( (maxValue > 0) && (bwValue > maxValue) )
    {
        alert (objName + " must be < "+maxValue);
        return false;
    }

    if ( (bwValue%multiple) != 0 )
    {
        alert (objName + " must be multiple of "+multiple+" kB");
        return false;
    }
    return true;
}

/* Validate the traffic profile bandwidth values. object names are hsardcoded
   "m_GTPBandwidth" x 512 kB  min  512, max 2621440
   "m_DBAUpsUbrBw" x 64 kB
   "m_DBAUpsCbrBw" x 64 kB
   "m_DBAAssuredBw" x 64 kB
   "m_DBAMaxBw" x 64 kB 
*/
function f_ValidateGponTrafficProfile()
{
    if ( f_GetItemValueByName('m_kCreateGTProfile') == 0 )
    {
        return true;
    }
    /* --------- m_GTPBandwidth -------------- */
    if ( _VerifyBandwidthValue("m_GTPBandwidth","Guaranteed Upstream Bandwidth", true, 0, 2621440, 512) == false )
    {
        return false;
    }
    /* --------- m_DBAUpsUbrBw -------------- */
    if ( _VerifyBandwidthValue("m_DBAUpsUbrBw","Fixed Upstream UBR Bandwidth", false, 128, 0, 64) == false )
    {
        return false;
    }
    /* --------- m_DBAUpsCbrBw -------------- */
    if ( _VerifyBandwidthValue("m_DBAUpsCbrBw","Fixed Upstream CBR Bandwidth", false, 512,0, 64) == false )
    {
        return false;
    }
    /* --------- m_DBAAssuredBw -------------- */
    if ( _VerifyBandwidthValue("m_DBAAssuredBw","Assured Upstream Bandwidth", false, 256, 0, 64) == false )
    {
        return false;
    }

    var maxBwRequired = f_GetItemValueByName("m_DBAUpsUbrBw");
    var maxBW = parseInt(maxBwRequired);

    maxBwRequired = f_GetItemValueByName("m_DBAUpsCbrBw");
    maxBW += parseInt(maxBwRequired);

    maxBwRequired = f_GetItemValueByName("m_DBAAssuredBw");
    maxBW += parseInt(maxBwRequired);
    
    /* --------- m_DBAMaxBw -------------- */
    var bwValue = f_GetItemValueByName("m_DBAMaxBw");

    if ( (bwValue%64) != 0 )
    {
        alert ("Maximum Upstream Bandwidth must be multiple of 64 kB");
        return false;
    }
    if ( bwValue < maxBW )
    {
        alert ("Maximum Upstream Bandwidth must be > "+maxBW);
        return false;
    }
    return true;
}

/* Initialize the slot selector title, for MX1U devices title it
   Ports, for multi slotted devices showq as "Slot". */
function InitSlotPortSelectorTitle(IsIdentMX1U)
{
    if ( IsIdentMx1U(IsIdentMX1U) )
    {
        document.getElementById('kSelectorTitle').innerHTML = ' Port Type';
    }
    else
    {
        document.getElementById('kSelectorTitle').innerHTML = ' Slot';
    }
    return;
}

/* Initialize the secondary slot selector title, for MX1U devices title it
   Ports, for multi slotted devices show as Sec. Slot. */
function InitSecSlotPortSelectorTitle(IsIdentMX1U)
{
    if ( IsIdentMx1U(IsIdentMX1U) )
    {
        document.getElementById('kSecSelectorTitle').innerHTML = ' Sec. Port Type';
    }
    else
    {
        document.getElementById('kSecSelectorTitle').innerHTML = ' Secondary Slot';
    }
    return;
}

/* Do not show slot select menu for these MX1U devices. */
function IsIdentMx1U(IsIdent1U)
{
    if ( IsIdent1U == "TRUE" )
    {
        return true;
    }
    return false;  
}


/* Returns TRUE if malcNextGen multi-shelf HA class system */
function IsIdentMalcNextGenHA(moduleIdentity)
{
    switch (moduleIdentity)
    {
        case "MODULE_MXK819HA":
        case "MODULE_MXK823HA":
        case "MODULE_MXK319HA":
            return true;
        break;
    }
    return false;
}


/* Returns TRUE if malcNextGen system */
function IsIdentMalcNextGen(moduleIdentity)
{
    switch (moduleIdentity)
    {
        case "MODULE_MXK819":
        case "MODULE_MXK823":
        case "MODULE_MXK319":
            return true;
        break;
    }
    return false;
}

/* Do not show slot select menu for these MX1U devices. */
function IsIdentMx1UGpon(moduleIdentity)
{
    switch (moduleIdentity)
    {
        case "MODULE_MX1U_194_GPON":
		    case "MODULE_MX1U_198_GPON":
		    case "MODULE_MX1U_194_GPON_10GE":
		    case "MODULE_MX1U_198_GPON_10GE":
		    case "MODULE_MX1U_194_GPON_TOP":
		    case "MODULE_MX1U_198_GPON_TOP":
		    case "MODULE_MX1U_194_GPON_10GE_TOP":
		    case "MODULE_MX1U_198_GPON_10GE_TOP":
            return true;
        break;
    }
    return false;  
}

/* Return true if module is mx1u198 or mx1u194 and its variations */
function IsIdentMxk1U19x(moduleIdentity)
{
    switch(moduleIdentity)
    {
        case "MODULE_MX1U_198_GPON":
		    case "MODULE_MX1U_198_GPON_10GE":
		    case "MODULE_MX1U_198_GPON_TOP":
		    case "MODULE_MX1U_198_GPON_10GE_TOP":
        case "MODULE_MX1U_194_GPON":
		    case "MODULE_MX1U_194_GPON_10GE":
		    case "MODULE_MX1U_194_GPON_TOP":
		    case "MODULE_MX1U_194_GPON_10GE_TOP":
            return true;
        break
    }
    return false;  
}

/* Return true if module is mx1ux80 or its variations */
function IsIdentMxk1Ux80(moduleIdentity)
{
    switch(moduleIdentity)
    {
        case "MODULE_MX180_4GE":
        case "MODULE_MXP180_4GE":
        case "MODULE_MX180_TP_RJ45_4GE":
        case "MODULE_MXP180_TP_RJ45_4GE":
        case "MODULE_MX180_LT_TP_RJ45_2GE":
        case "MODULE_MX180GE_6GE_SFP":
        case "MODULE_MX180GE_6GE_RJ45":

        case "MODULE_MXP280_TP_RJ45_3GE1GPON":
        case "MODULE_MX280_3GE1GPON":
        case "MODULE_MXP280_3GE1GPON":
        case "MODULE_MX280_TP_RJ45_3GE1GPON":
            return true;
        break
    }
    return false;  
}

/* Returns TRUE if Mx1Ux6x system */
function IsIdentMx1U26x(moduleIdentity)
{  
    switch (moduleIdentity)
    {
        case "MODULE_MX260_3GE1GPON":
        case "MODULE_MX261_3GE1GPONSPLTR600":
        case "MODULE_MX262_3GE1GPONSPLTR900":
        case "MODULE_MXP260_3GE1GPON":
        case "MODULE_MX160_4GE":
        case "MODULE_MX161_4GESPLTR600":
        case "MODULE_MX162_4GESPLTR900":
        case "MODULE_MXP160_4GE":
        case "MODULE_MX160_16P_2GE":
        case "MODULE_MX160LT_8P_2GE":
            return true;
        break;
    }
    return false;
}

/* In mx1Ux5x 1U systems we need to create global bridge by accepting 
 * vlan=0, slan=0 dtagged and vlan=0 stagged bridges, Create Global 
 * bridge only for mx15x and mxp15x
 * Return true if valid.
 */
function IsIdentMx1Ux5x(moduleIdentity)
{
    switch (moduleIdentity)
    {
        case "MODULE_MX150_2GE":
        case "MODULE_MX151_2GESPLTR600":
        case "MODULE_MX152_2GESPLTR900":
        case "MODULE_MXP150_2GE":
            return true;
        break;
    }
    return false;
}

/* Do not show slot select menu for these MX1U devices. */
function IsIdentMx1UActvE(moduleIdentity)
{
    switch (moduleIdentity)
    {
         case "MODULE_MXP180_4GE":
         case "MODULE_MXP280_3GE1GPON":
         case "MODULE_MX180_4GE":
         case "MODULE_MX280_3GE1GPON":
         case "MODULE_MXP280_TP_RJ45_3GE1GPON":
         case "MODULE_MXP180_TP_RJ45_4GE":
             return true;
        break;
    }
    return false;  
}

/* Draw the name and value of shelf selected. Return the shelf number. */
function f_InsertCurrentShelfValue(number,mx1U)
{
    if ( mx1U == 'TRUE' )
    {
        document.getElementById('kShelfLabel').innerHTML = '';
        document.getElementById('kShelfValue').innerHTML = '';
    }
    else
    {
        document.getElementById('kShelfLabel').innerHTML = 'Shelf';
        document.getElementById('kShelfValue').innerHTML = number;
    }
    return number;
}

function f_InsertCurrentSlotValue(number,mx1U)
{
    if ( mx1U == 'TRUE' )
    {
        document.getElementById('kSlotLabel').innerHTML = 'Port Type';
        if ( number == '1' )
        {
            document.getElementById('kSlotValue').innerHTML = 'uplink';
        }
        else if ( number == '2' )
        {
            document.getElementById('kSlotValue').innerHTML = 'downlink';
        }
        return;
    }
    document.getElementById('kSlotLabel').innerHTML = 'Slot';
    document.getElementById('kSlotValue').innerHTML = number;
}

function f_InsertCurrentPortValue(number,name)
{
    document.getElementById('kPortLabel').innerHTML = name;
    document.getElementById('kPortValue').innerHTML = number;
}

function f_InsertCurrentSubPortValue(number,name)
{
    document.getElementById('kSubPortLabel').innerHTML = name;
    document.getElementById('kSubPortValue').innerHTML = number;
}

/* Init the fields with PoE range 1 through max nunber */
function f_InsertCurrentPoEValue(number,name)
{
    document.getElementById('kPoELabel').innerHTML = name;
    if ( number > 0 )
    {
        document.getElementById('kPoEValue').innerHTML = " 1-"+number;
    }
    else
    {
        document.getElementById('kPoEValue').innerHTML = " none";
    }
}

/* Aggregate all downlink_xxxx subtype to downlink */
function IsLogicalTypeDownlink(LogicalType)
{
    switch (LogicalType)
    {
        case kBRLOG_DNLINK:
        case kBRLOG_DNLINKDATA:
        case kBRLOG_DNLINKPPPOE:
        case kBRLOG_DNLINKPPPOA:
        case kBRLOG_DNLINKP2P:
        case kBRLOG_DNLINKUSMCAST:
        case kBRLOG_DNLINKVIDEO:
        case kBRLOG_DNLINKVOICE:
            return true;
        break;
    }
    return false;
}

/* ---------------------------------------------------------------------------
 * If GEM ID is entered as 5xx, then its association with ONU port number must
 * be validated. That is. GEM = 501 can only be used for ONU 1, ... upto 564 
 * for ONU 64. All other combinations are allowed.
 * --------------------------------------------------------------------------*/
function f_ValidateGemPort(EncGem, OnuPort, GemAutoAssign)
{
    var commitMesg = "GEM Port reservation policy for range 501-564     \n\n";
    var errMesg    = commitMesg;

    if ( GemAutoAssign == true )
    {
        return true;
    }

    if ( (EncGem < 501) || (EncGem > 564) )
    {
        return true;
    }

    var Gem = Math.floor(EncGem/100);
    Gem = EncGem - (Gem * 100);
    var Onu = parseInt(OnuPort);

    if ( Onu != Gem )
    {
        var validGem = Onu + 500;
        var errMesg = errMesg + "Only GEM Port "+validGem+" can be allocated to ONU "+ OnuPort;

        alert(errMesg);
        return false;
    }
    return true;
}

/* Only accept numberl key chars (MB_INTEGER) */
function f_KeyStroke(evt, name)
{
    var charCode = (evt.which) ? evt.which : event.keyCode

    if ( (charCode < 31) )
    {
        return true;
    }

    switch (name)
    {
        /* Unsigned integers */
        case "MB_INTEGER":
        case "MB_MULTIPLE512":
            if ( (charCode >= 48) && (charCode <= 57) )
            {
                return true;
            }
            return false;
        break;

        /* Signed integers */
        case "MB_SIGNEDINTEGER":
            if ( (charCode == 45) || 
                 (charCode >= 48) && (charCode <= 57) )
            {
                return true;
            }
            return false;
        break;

        case "MB_IPADDRESS":
        case "MB_EXTERNIPADDR":
            if (charCode == 46)
            {
                return true;
            }

            if ( (charCode >= 48) && (charCode <= 57) )
            {
                return true;
            }
            return false;
        break;

        case "MB_PHYSADDRESS":
        case "MB_EXTERNPHYSMAC":
        case "MB_EXTERNIPV6MAC":
            if (charCode == 58)
            {
                return true;
            }

            if ( (charCode >= 48) && (charCode <= 57) )
            {
                return true;
            }

            if ( (charCode >= 97) && (charCode <= 102) )
            {
                return true;
            }

            if ( (charCode >= 65) && (charCode <= 70) )
            {
                return true;
            }
            return false;
        break;
    }
    /* Any other case, allow the char */
    return true;
}

/* If the section is in collapsed mode, then change to expanded */
function ShowSectionExpanded(profileId)
{
    var expandDiv   = "div_Expand_" + profileId;
    var collapseDiv = "div_Collapse_" + profileId;

    gf_SetDisplayMode(expandDiv, kHide);
    gf_SetDisplayMode(collapseDiv, kShow);
}

/* If the section is in expanded mode, then change to collapsed */
function ShowSectionCollapsed(profileId)
{
    var expandDiv   = "div_Expand_" + profileId;
    var collapseDiv = "div_Collapse_" + profileId;

    gf_SetDisplayMode(expandDiv, kShow);
    gf_SetDisplayMode(collapseDiv, kHide);
}

function ShowWaitCursor()
{
    document.body.style.cursor='wait';
}

function ShowDefaultCursor()
{
    document.body.style.cursor='default';
}

/* Reject the special chars in input text string */
function f_IsTextInputValid(inputStr)
{  
    if ( inputStr == null )
    {
        return false;
    }
   
    if ( inputStr.length == 0 )
    {
        return false;
    }

    var validStr = /^[A-Za-z][a-zA-Z0-9-_.]+$/;
    if(inputStr.match(validStr))  
    {
        return true;
    }
    return false;
}

//-->

